/*  Harold H. Ipolyi		11 June 1994, 1995
======================README======================
Short:    WWW HTML's from Scion Genealogy dbs's
Uploader: ipolyi@pat.mdc.com (Harold H. Ipolyi)
Author:   Harold H. Ipolyi
Type:     util/rexx
LastRev:  24 Sep 1995
_____________________________________________________________________________

 Scion Genealogist  Rob Akins (biz/dbase/Scion.lha) is comprehensive,
 easy to use, and provides Arexx ports for extracting data.
_____________________________________________________________________________

 Scion2html.rexx can repeatedly and painlessly recreate HTML files from
 entries in Scion data bases for cross-platform viewing via Mosaic, etc.

 Scion2html.rexx can also create AmigaGuide style ".guide" hypertexts
_____________________________________________________________________________

 GfxCon  Dirk Farin (gfx/conv/gfxcon.lha) is used to make Thumbnails
 from Scion data base pictures as links to Picture Albums
_____________________________________________________________________________

 an interesting example Genealogy is included: see after [Release History]
_____________________________________________________________________________

Prerequisites:	ScionGenealogist V 4.07+  Rob Akins
		ARexx (of course :)
		rexxsupport.library
		rexxarplib.library
		HTML/WWW browser (AMosaic, Mosaic, HotJava, ... )

	 also:		(to incorporate and display in-line pictures)
		GfxCon V1.7+  Dirk Farin ( in: Sys:Tools)
		Amiga OS 3.0+ for displaying picture datatypes
_____________________________________________________________________________

 to install: just drag Scion2html.rexx & its ICON into REXX:

    however: can be executed from anywhere by double-clicking the ICON

======================README======================

     PICTURES from [P|F]P{IRN}.DBNAME are links to Picture Albums (  )
                  (please see PP & FP Notes)

Tested:
||	on Amiga3000 Kickstart v.37.175 Workbench v.38.35
|    assume   |	&  Amiga3000 Kickstart v.40.68  Workbench v.40.42
|  TradeMarks |	w/ ScionGenealogist V 3.06 & Mosaic1.2NoNet
|      &      |	w/ ScionGenealogist V 3.13 & Mosaic1.3betaAmitcp
|  CopyRights |	w/ ScionGenealogist V 4.07 & Mosaic2.0Prerelease
|     as      |
| appropriate |	HTML file compatibility tested on: AMosaic, HotJava,
|_____________|	NCSA Mosaic (Sun), Netscape (Sun), Netscape (Mac)

Bugs:		If a new Thumbnail format is selected, the user must
		manually edit the Picture Album files to reflect the
		new Thumbnail suffixes.       (It is assumed that the
		Picture Album files may have been  User  modified and
		must therefore be protected against auto-regeneration)

Release History:

 11 Jun 1994  ScionToMosaic.rexx for ScionGenealogist V 3.06

 19 Jun 1994  MakeDir(Gdir) fixed; extra comments processed.

 25 Jun 1994  Fixed descenders; Women in List italicised
              updated for ScionGenealogist V 3.13

  3 Sep 1994  Replaces occurrences of "<ScionIRN>" by NAMES from DB
                e.g. Replaces <101> by Iam Onehundredone, Jr.
              Added Family Info file processing; Ancestor trees
              Added descendant charts
              Women italicised; men boldface everywhere
              Added creation of a textual file "GenealogyOf..."

  1 Mar 1995  cleaned up bugs in creation of textual files

  6 Jun 1995  renamed ScionToMosaic to Scion2html
                (somehow it kept winding up in "music" on AmiNet)
              date format in "ancestors" section normalized
              images used as links to picture albums (see
               PP & FP Notes) and links to pictures
              GfxCon >V1.5 used for picture copying and reducing
              recoded for DOS/Windows restricted 8.3 file names

 26 Jun 1995  A little comments cleanup after the last changes
              skip remaking of files when unnecessary
              another new wrinkle for one of the users:
                  special file name prefixes ( GenPrefix )

  1 Jul 1995  added graphics to Ancestors charts
              allow family picture album sans family info file
              Thumbnail size now user settable ( at line 3 )

  5 Jul 1995  (more info)  ( )
              (family info)  (  )
              (Picture Album)  (  )
              () () glyphs added to Ancestor, Descendant charts
              Thumbnail format {GIF|JPEG} now user settable
               ( suffix still .gif in all cases )

  1 Aug 1995  updated for release with ScionGenealogist V 4.07
              set correct stack size (21000) for GfxCon
              JPEG now the default Thumbnail format
                  (smaller files, no  problems, looks better)
              changing of configuration added
              configuration now saved in S:Scion2html.Config

 12 Aug 1995  fix some bugs that creeped in with updated to Scion4.07
              handling of more of the new ScionV4.07 data fields
              using CheckForReplacement to create all anchors
              changed appearance of family & descendant charts
              configuration is displayed at startup

 24 Sep 1995  ".guide" style hypertext generation added
               Guide picture VIEWER set to MultiView for OS => 3.0
              person information now in person.[array]
              initial settings now in flags.[array]
              verbose flag for extra progress reporting details
              bold flag for: male boldface & female italic
              removed undocumented buggy feature of replacing ocurrences
               of [ScionIRN] (now only replaces ocurrences of <ScionIRN>)
              fixed a GenPrefix init bug (couldn't reset back to null)
              

 (: "uudecode Scion2html.rexx" <- extracts an interesting Genealogy :)
 (:  hint: compare the names of the GreatGrandParents on both sides :)

   ( start a shell                  )
   ( cd work:                       ) some work directory
   ( uudecode Rexx:Scion2html.rexx  ) whatever uudecode equiv you use
   ( run Scion Samms                ) load data base into Scion
   ( rx Scion2html.rexx Normal      ) in shell back on WB screen

  the following can be safely left here 

begin 755 Samms
M4V-I;VX`-"XP,```3@``%``)```@0P5%9&ET``56:65W``9!1$%-4P`%0T%)U
M3@`%04U%4P`*JU5.2TY/5TZ[``E/3$U35$5!1``&4T%-35,``0`!``(@``(@(
M``(@``(@``(@```!``$!``D&4T%-35,`!U9I<F=I;``"30`!``$``0`6(D9IF
M<G-T($QE;G-M86X@4V%M;7,B``$`*BAD97-C96YD960@9G)O;2!O;FQY(#0@F
M1W)E871'<F%N9%!A<F5N=',I`#A3;VQA<FEA;B!#;W5N8VEL;&]R('P@4')ES
M<VED96YT(&]F('1H92!'86QA8W1I8R!#;W5N8VEL`#]A;&UO<W0M='=I;B!O/
M9B!T=VEN<R`\-CX@)B`\-SXL(&AI<R`B<75A9')U<&QE('-E8V]N9"!C;W5S]
M:6YS(@``````+D-H+C@@;V8@(D9I<G-T($QE;G-M86XB(&)Y($4N($4N(%-M[
M:71H+"!0:"Y$+@`!``$``0`!``$```(``P$``09304U-4P`02F%M97,@06QEN
M>&%N9&5R``)-``$``0`!``$``0`!``$`&V]N;'D@8VAI;&0@;V8@/#@^(&%N/
M9"`\,30^```````N0V@N."!O9B`B1FER<W0@3&5N<VUA;B(@8GD@12X@12X@R
M4VUI=&@L(%!H+D0N``$``0`!``$``0```P`%`0`!"4],35-414%$``9387)AG
M:``"1@`!``$``0`!``$``0`!`!QO;FQY(&-H:6QD(&]F(#PQ,CX@86YD(#PQ+
M,#X``````"Y#:"XX(&]F(")&:7)S="!,96YS;6%N(B!B>2!%+B!%+B!3;6ET:
M:"P@4&@N1"X``0`!``$``0`!```$``8!``()3TQ-4U1%040`!4IO:&X``DT`C
M`0`!``$``0`!``$``0`<;VYL>2!C:&EL9"!O9B`\,3,^(&%N9"`\,3$^````+
M```N0V@N."!O9B`B1FER<W0@3&5N<VUA;B(@8GD@12X@12X@4VUI=&@L(%!H8
M+D0N``$``0`!``$``0``!0`$`0`"!E-!34U3``9)<F5N90`"1@`!``$``0`!]
M``$``0`!`!MO;FQY(&-H:6QD(&]F(#PY/B!A;F0@/#$U/@``````+D-H+C@@^
M;V8@(D9I<G-T($QE;G-M86XB(&)Y($4N($4N(%-M:71H+"!0:"Y$+@`!``$`;
M`0`!``$```8``@`)3TQ-4U1%040`!T=E;W)G90`"30`!``$``0`!``$``0`!C
M`#94=VEN(&)R;W1H97(@;V8@/#<^.R`B<75A9')U<&QE('-E8V]N9"!C;W5SZ
M:6XB(&]F(#PQ/@``````+D-H+C@@;V8@(D9I<G-T($QE;G-M86XB(&)Y($4N5
M($4N(%-M:71H+"!0:"Y$+@`!``$``0`!``$```<``@`)3TQ-4U1%040`!%)A#
M>0`"30`!``$``0`!``$``0`!`#94=VEN(&)R;W1H97(@;V8@/#8^.R`B<75A&
M9')U<&QE('-E8V]N9"!C;W5S:6XB(&]F(#PQ/@``````+D-H+C@@;V8@(D9I@
M<G-T($QE;G-M86XB(&)Y($4N($4N(%-M:71H+"!0:"Y$+@`!``$``0`!``$`8
M``@`!P$``P9304U-4P`%0FEL;``"30`!``$``0`!``$``0`!`#-4=VEN(&)R!
M;W1H97(@;V8@/#D^+"!S:7-T97)S(#PQ,#X@)B`\,3$^(&%R92!T=VEN<P``M
M````&"AN;R!F:7)S="!N86UE(&EN(&)O;VLI``$``0`!``$``0``"0`'`0`$K
M!E-!34U3``57:6QL``)-``$``0`!``$``0`!``$`,U1W:6X@8G)O=&AE<B!OT
M9B`\.#XL('-I<W1E<G,@/#$P/B`F(#PQ,3X@87)E('1W:6YS```````8*&YO8
M(&9I<G-T(&YA;64@:6X@8F]O:RD``0`!``$``0`!```*``<!``4&4T%-35,`7
M!4=I;&P``D8``0`!``$``0`!``$``0`R5'=I;B!S:7-T97(@;V8@/#$Q/BP@G
M8G)O=&AE<G,@/#@^("8@/#D^(&%R92!T=VEN<P``````&"AN;R!F:7)S="!NT
M86UE(&EN(&)O;VLI``$``0`!``$``0``"P`'`0`&!E-!34U3``5*:6QL``)&;
M``$``0`!``$``0`!``$`,E1W:6X@<VES=&5R(&]F(#PQ,#XL(&)R;W1H97)SZ
M(#PX/B`F(#PY/B!A<F4@='=I;G,``````!@H;F\@9FER<W0@;F%M92!I;B!BW
M;V]K*0`!``$``0`!``$```P`"`$`!0E/3$U35$5!1``%2F%C:P`"30`!``$`"
M`0`!``$``0`!`#14=VEN(&)R;W1H97(@;V8@/#$S/BP@<VES=&5R<R`\,30^\
M("8@/#$U/B!A<F4@='=I;G,``````!@H;F\@9FER<W0@;F%M92!I;B!B;V]K;
M*0`!``$``0`!``$```T`"`$`!@E/3$U35$5!1``%36%C:P`"30`!``$``0`!`
M``$``0`!`#14=VEN(&)R;W1H97(@;V8@/#$R/BP@<VES=&5R<R`\,30^("8@?
M/#$U/B!A<F4@='=I;G,``````!@H;F\@9FER<W0@;F%M92!I;B!B;V]K*0`!?
M``$``0`!``$```X`"`$``PE/3$U35$5!1``$1F%Y``)&``$``0`!``$``0`!R
M``$`-%1W:6X@<VES=&5R(&]F(#PQ-3XL(&)R;W1H97)S(#PQ,CX@)B`\,3,^\
M(&%R92!T=VEN<P``````&"AN;R!F:7)S="!N86UE(&EN(&)O;VLI``$``0`!!
M``$``0``#P`(`0`$"4],35-414%$``1-87D``D8``0`!``$``0`!``$``0`TN
M5'=I;B!S:7-T97(@;V8@/#$T/BP@8G)O=&AE<G,@/#$R/B`F(#PQ,SX@87)E>
M('1W:6YS```````8*&YO(&9I<G-T(&YA;64@:6X@8F]O:RD``0`!``$``0`!K
M```0```!``<&4T%-35,`!T%L8F5R=``"30`!``$``0`!``$``0`!``$`````7
M`"Y#:"XX(&]F(")&:7)S="!,96YS;6%N(B!B>2!%+B!%+B!3;6ET:"P@4&@N&
M1"X``0`!``$``0`!```1```!``@)3TQ-4U1%040`"$-H97-T97(``DT``0`!:
M``$``0`!``$``0`!```````N0V@N."!O9B`B1FER<W0@3&5N<VUA;B(@8GD@O
M12X@12X@4VUI=&@L(%!H+D0N``$``0`!``$``0``$@```0`'!D%$04U3``=!B
M9&5L;&4``D8``0`!``$``0`!``$``0`!```````4*&YO="!N86UE9"!I;B!B!
M;V]K*0`!``$``0`!``$``!,```$`"`5#04E.``A#86UI;&QE``)&``$``0`!]
M``$``0`!``$``0``````%"AN;W0@;F%M960@:6X@8F]O:RD``0`!``$``0`!G
M```4``D`!E-!34U3``E6:7)G:6QI80`"1@`!``$``0`!``$``0`!``$`````T
M``$``0`!``$``0`!```!``(``P$``0$``0`!``$```````$``0`!``$``0``7
M`0```@`$``4"``8`!P$``0`!``$```````$``0`!``$``0```0```P`(``X!_
M``(!``$``0`!```````!``$``0`!``$```$```0`"0`/`0`%`0`!``$``0``R
M`````0`!``$``0`!```!```%``P`"@$``P$``0`!``$```````$``0`!``$`M
M`0```0``!@`-``L!``0!``$``0`!```````!``$``0`!``$```$```<`$``28
M!``(``D`"@`+`0`!``$``0```````0`!``$``0`!```!```(`!$`$P0`#``-]
M``X`#P$``0`!``$```````$``0`!``$``0```0``"0`!```!`!0!``$``0`!*
2```````!``$``0`!``$```$`&
``
end
size 2988

  -----------------------------------------------------------------
 | Conventions that I followed in my ScionGenealogist data base:   |
 |                                                                 |
 |   lastnames kept pure (no honorifics, Jr's, III's )            |
 |                                                                 |
 |   given names have any and all honorifics AFTER a COMMA        |
 |                                                                 |
 |  for example:  LastName      FirstNames, honorifics             |
 |                                                                 |
 |                BAUER-GAUSS   Joseph, Dr.                        |
 |                DAGLEY        Richard Kelley, Jr.                |
 |                                                                 |
 |-----------------------------------------------------------------|
 |                                                                 |
 |  For a name change (NOT maidenname > marriedname), try this:    |
 |                New           Birth Name > Changed To, Ph. D.    |
 |     which lists as: Birth Name > Changed To New, Ph. D.         |
 |                                                                 |
  -----------------------------------------------------------------



                                                                
 GetLastName: PROCEDURE at end of script capitalizes Last Names 
 -------------------------------------------------------------  
 | it can also be used to handle "non-conforming" Last Names |  
 |                e.g. "MAC ISAAC" --> "MacISAAC"            |  
 |                     "VON NUEMANN" --> "VonNuemann"        |  
 -------------------------------------------------------------  
 BUT: you must add the additional tests yourself (it's easy!)   
                                                                



 |-----------------------------------------------------------------|
 |                                                                 |
 |  if Death Date is blank; Death Place can be a COMMENT field    |
 |                                            e.g. Phone #         |
 |  if Burial Date is blank; Burial Place can be a COMMENT field  |
 |                                            e.g. Address         |
  -----------------------------------------------------------------

 * 'rx Scion2html.rexx Normal' automagically [re]creates a .htm file for
 * each person in your ScionGenealogist data base; following the TEMPLATE:

############# begin genealogytemplate.html ####################################
<TITLE>Person Data Sheet</TITLE>
<PRE><TT>
<A href="Person#a.html"><img src="Person#I.jpg"></A>
<B>Person</B> (<A HREF="Person#I.html">  </A>) (<A href="Person#a.html"><B>  </B></A>) (<A href="Genealogy/GenealogyFile.html"><B>List of Persons.</B></A>)
Born: birthdate * birthplace <BR>
Died: deathdate + deathplace . Buried: burialplace <BR>
<HR>
<H2>List of Persons in data base.</H2><P>
<A HREF="Person#.html"><B>malePerson</B></A> * birthdate + deathdate <A HREF="Father.html"><B>Father</B></A>_&_<A HREF="Mother.html"><I>Mother</I></A><BR>
<A HREF="Person#.html"><I>femalePerson</I></A> * birthdate + deathdate <A HREF="Father.html"><B>Father</B></A>_&_<A HREF="Mother.html"><I>Mother</I></A><BR>
<HR>
<H3>Immediate Family of <I>Person</I></H3> ( Parents, Siblings, Spouse, and Children )
  <A HREF="Father.html"><B>Father</B></A>_&_<A HREF="Mother.html"><I>Mother</I></A> & mdate @ mplace
  |            (<A HREF="Family#I.html">  </A>) (<A href="Family#a.html"><B>  </B></A>)
  |_____ <A HREF="sibling1.html">sibling1</A> * sibling1birthdate + sibling1deathdate
  |_____ <A HREF="siblingN.html">siblingN</A> * siblingNbirthdate + siblingNdeathdate
  |             
  <b>Person</b>_&_<A HREF="Spouse1.html"><I>Spouse1</I></A> & m1date @ m1place
  |  |  |            (<A HREF="Family#I.html">  </A>) (<A href="Family#a.html"><B>  </B></A>)
  |  |  |_____ <A HREF="m1child1.html"><I>m1child1</I></A> * m1child1birthdate + m1child1birthdate
  |  |  |_____ <A HREF="m1childN.html"><B>m1childN</B></A> * m1childNbirthdate + m1childNbirthdate
  |  |
  |  |_&_<A HREF="Spouse2.html"><I>Spouse2</I></A> & m2date @ m2place
  |    |            (<A HREF="Family#I.html">  </A>) (<A href="Family#a.html"><B>  </B></A>)
  |    |_____ <A HREF="m2child1.html"><B>m2child1</B></A> * m2child1birthdate + m2child1birthdate
  |    |_____ <A HREF="m2childN.html"><I>m2childN</I></A> * m2childNbirthdate + m2child2birthdate
  |
  |_&_<A HREF="Spousen.html"><I>Spousen</I></A> & mNdate @ mNplace
    |            (<A HREF="Family#I.html">  </A>) (<A href="Family#a.html"><B>  </B></A>)
    |_____ <A HREF="mNchild1.html"><I>mNchild1</I></A> * mNchild1birthdate + mNchild1birthdate
    |_____ <A HREF="mNchildN.html"><I>mNchildN</I></A> * mNchildNbirthdate + mNchildNbirthdate
<HR>
Ancestors
          - <A HREF="GreatGrandFather.html"><B>GreatGrandFather</B></A> (FFF) * birthdate + deathdate
      - <A HREF="GrandFather.html"><B>GrandFather</B></A> (FF) * birthdate + deathdate
          - <A HREF="GreatGrandMother.html"><I>GreatGrandMother</I></A> (FFM) * birthdate + deathdate
  - <A HREF="Father.html"><B>Father</B></A> (F) * birthdate + deathdate
          - <A HREF="GreatGrandFather.html"><B>GreatGrandFather</B></A> (FMF) * birthdate + deathdate
      - <A HREF="GrandMother.html"><I>GrandMother</I></A> (FM) * birthdate + deathdate
          - <A HREF="GreatGrandMother.html"><I>GreatGrandMother</I></A> (FMM) * birthdate + deathdate
Person * birthdate + deathdate
          - <A HREF="GreatGrandFather.html"><B>GreatGrandFather</B></A> (MFF) * birthdate + deathdate
      - <A HREF="GrandFather.html"><B>GrandFather</B></A> (MF) * birthdate + deathdate
          - <A HREF="GreatGrandMother.html"><I>GreatGrandMother</I></A> (MFM) * birthdate + deathdate
  - <A HREF="Mother.html"><I>Mother</I></A> (M) * birthdate + deathdate
          - <A HREF="GreatGrandFather.html"><B>GreatGrandFather</B></A> (MMF) * birthdate + deathdate
      - <A HREF="GrandMother.html"><I>GrandMother</I></A> (MM) * birthdate + deathdate
          - <A HREF="GreatGrandMother.html"><I>GreatGrandMother</I></A> (MMM) * birthdate + deathdate
<HR>
Descendants
  <B>Person</B> * birthdate
  &_<A HREF="Spouse1.html"><I>Spouse1</I></A> * birthdate
   | <A HREF="m1child1.html"><I><B>m1child1</B></I></A> * m1child1birthdate
   | <A HREF="m1child.html"><B><B>m1childN</B></B></A> * m1childNbirthdate
  &_<A HREF="Spouse2.html"><I>Spouse2</I></A> * birthdate
   | <A HREF="m2child1.html"><B>m2child1</B></A> * m2child1birthdate
   | <A HREF="m2childN.html"><I>m2childN</I></A> * m2childNbirthdate
   | &_<A HREF="m2childNSpouse1.html"><I>m2childNSpouse1</I></A>
   |  | <A HREF="m2childNchild1.html"><B>m2childNchild1</B></A>
  &_<A HREF="Spousen.html"><I>Spousen</I></A> * birthdate
   | <A HREF="mNchild1.html"><I>mNchild1</I></A> * mNchild1birthdate
   | <A HREF="mNchildN.html"><I>mNchildN</I></A> * mNchildNbirthdate
<HR>
     a template to represent Genealogy data in HTML hypertext.
 * replace all ocurrences of each appropriate ITEM with ACTUAL DATA
     e.g. search-replace-all Person with: My Name
     e.g. query-search-replace Mother with: My Mother's Name
 * judiciously edit .htm file names in anchors
 * add/remove lines for children, siblings, spouses as necessary
</TT></PRE>
</HTML>
############### end genealogytemplate.html ###################################

 * In an HTML file (maybe HOME PAGE) have an anchor pointing to GenealogyFile:

 * ( see the hint at the end of a NORMAL run or specify ANCHOR )
_____________________________________________________________________________

 * The PN{IRN}.DBNAME files are used to generate the "  " files.

 * Whenever the PN{IRN}.DBNAME is changed or replaced, the corresponding
 * "  " file will be updated if 'rx Scion2html.rexx {IRN}' is re-run.

 * PP & FP Notes: (personal & family pictures; picture albums "  ")
 * ScionGenealogist names pictures as;
 *      PP{IRN}.DBNAME (personal) and FP{mFGRN}.DBNAME (family)
 * {P|F}P{IRN|mFGRN}.DBNAME now used as pictures & links.
 *    GfxCon is used to copy/reduce jpegs from {P|F}P{IRN|mFGRN}.DBNAME
 *    reductions are anchors pointing to HTML's for pictures albums
 *    reductions in pictures albums are anchors pointing to pictures
 *  picture albums will not be overwritten; they may be updated with
 *    additional pictures; links to other pictures, etc.

 * Whenever picture {P|F}P{IRN|mFGRN}.DBNAME is changed or replaced,
 *  the corresponding images will be updated

 * {P|F}P{IRN|mFGRN}.DBNAME may be any legal GfxCon input picture FORMAT:
 * (ILBM,RGB8,PCX,BMP,RLE8,TIFF,Targa,LBM,RGBN,IMG,RLE4,GIF,JPEG,RGB-Raw)
*/

			/*   some Intitializations = default		*/
flags.Thumbnail = 350	/* Thumbnail maximum dimensions			*/
flags.Thmbfmt = "JPEG"	/* Thumbnail format { GIF | JPEG }		*/
flags.MakeText = 0	/* 1 to also make printable ASCII text file	*/
flags.MakeGuide = 0	/* 1 to also make ".guide" hypertext files	*/
 flags.verbose = 0	/* 1 for verbose progress reports		*/
flags.bold = 0		/* 0 male boldface & female italic		*/
flags.GenPrefix = ""	/* needs only be set for specific circumstances 
			 ( if this makes no sense, you don't need it :) */

sayASCII = ' plain ASCII printable files'
sayguide = ' ".guide" hypertext files'
bolditalic = ' using [1mboldface  men[22m and [3mitalic  women[23m'
progress = ' progress reports'

GoodScion2html = Open('Scion2html','S:Scion2html.Config','r')

if GoodScion2html then do
 Mdir = readln('Scion2html')
 flags.Thumbnail = readln('Scion2html')
 flags.Thmbfmt = readln('Scion2html')
 flags.coumpound = readln('Scion2html')
 flags.MakeGuide = bittst(flags.coumpound,2)
/* flags.verbose */
 flags.bold = bittst(flags.coumpound,1)
 flags.MakeText = bittst(flags.coumpound,0)
 flags.GenPrefix = readln('Scion2html')
 Close('Scion2html')

 say '  [4m                     [24m'
 say '  [7m S:Scion2html.Config [27m [1msettings[22m:'
 say '  output destination: 'Mdir
 end

else do
 say '  [4m         [24m'
 say '  [7m default [27m [1msettings[22m:'
 say '  output destination: (will be set later)'
 end

say '  Thumbnail: 'flags.Thmbfmt' max 'flags.Thumbnail'x'flags.Thumbnail
if flags.GenPrefix ~= '' then say '  GeneralPrefix = 'flags.GenPrefix
 else say '  GeneralPrefix = {default} [special circumstance only]'
if flags.MakeGuide then say ' also make'sayguide
 else say '  skip making'sayguide
if flags.MakeText then say ' also make'sayASCII
 else say '  skip making'sayASCII
if ~flags.bold then say ' 'bolditalic
 else say ' NOT'bolditalic
if flags.verbose then say ' verbose'progress
 else say '  minimal'progress' (during normal runs)'
say ' '

if flags.GenPrefix = "" then flags.GenPrefix = "GENEAFI"

/* add libraries */
libs = 'rexxsupport.library rexxarplib.library'
DO i = 1 TO Words(libs)
 lib = Word(libs,i)
 if ~Show('Lib',lib) then do
  if EXISTS('LIBS:'lib) then call addlib lib, 0, -30
  else do
   'message "ERROR: cannot find' lib 'in LIBS:"'
   AskExit()
   end
  end
 end i

Address "SCIONGEN"	/* Point at Scion Genealogist port */
options RESULTS

if Show(p,'SCIONGEN') then do
 'GETDBNAME'	 /* Issue GET DB NAME command to Scion Genealogist */
 DBNAME = RESULT
 'GETTOTALIRN'
 TOTALIRN = RESULT
 if TOTALIRN = 0 then do
 SAY '[7m                                                                  '
 SAY '   Scion Genealogist is currently displaying an EMPTY data base!  '
 SAY '                                                                  [27m'
 SAY ' '
 AskExit()
  end
 end

else do
 SAY '[7m                                                               '
 SAY '   Scion Genealogist is NOT currently displaying a data base:  '
 SAY '                                                               '
 SAY ' Please start Scion; load desired data base; then try again... '
 SAY '                                                               [27m'
 SAY ' '
 AskExit()
 end

PARSE ARG flags.target
flags.target = Upper(strip(flags.target,,'"')) /* just in case, remove errant quotes */

origThumbnail = flags.Thumbnail
origThumbformat = flags.Thmbfmt

blanks = '                                                        '

flags.DoPictures = CheckGfxCon()

DO WHILE flags.target = '' | flags.target = '?' | flags.target = '/'
 SAY ' '
 if flags.target = '?' | flags.target = '/' then do
  SAY ' please send comments, questions to: [1mipolyi@pat.mdc.com[22m'
  SAY '		                            or:'
  SAY '	         [1mScion2html.rexx[22m    [1mHarold H. Ipolyi '
  SAY ' 	                             P.O.Box 891206 '
  SAY ' 	                             Houston, Tx 77289-1206[22m'
  SAY '   ____________________________________________________________'
  SAY '  /                                                            \'
  SAY ' / to [re]create HTML hypertext from ScionGenealogist data base \'
  SAY ' \ also, optionally, AmigaGuide style hypertexts or plain ASCII /'
  SAY '  \____________________________________________________________/'
  SAY ' '
  SAY '                           [4m      [24m'
  SAY ' defaults: may be changed; [7mRETURN[27m accepts [[3mvalue[23m]'
  svMdir = Mdir
  SAY '                    [4m'substr(blanks,1,length(DBNAME)+3)'[24m'
  call writech(stdout,' HTMLs in directory [7m 'DBNAME'G [27m within ['Mdir'] ')
  PULL Mdir
  if Mdir = '' then Mdir = svMdir
  SAY ' '
  svGeneralPrefix = flags.GenPrefix
  call writech(stdout,' General Prefix ')
  if flags.GenPrefix ~= 'GENEAFI' then call writech(stdout,'(. to reset) ')
  call writech(stdout,' = [')
  if flags.GenPrefix ~= 'GENEAFI' then call writech(stdout,flags.GenPrefix)
  call writech(stdout,'] ')
  PARSE PULL flags.GenPrefix
  if flags.GenPrefix = '' then flags.GenPrefix = svGeneralPrefix
  else if flags.GenPrefix = '.' then flags.GenPrefix = 'GENEAFI'
  SAY ' '
  if ~flags.MakeGuide then writech(stdout,' NOT')
  else writech(stdout,' Also')
  writech(stdout,' making'sayguide'; ')
  call writech(stdout,' acceptable? [yes] ')
  PULL answer
  if answer ~= '' then do
   if substr(answer,1,1) = 'N' then flags.MakeGuide = ~flags.MakeGuide
   end
  SAY ' '
  if ~flags.MakeText then writech(stdout,' NOT')
  else writech(stdout,' Also')
  writech(stdout,' making'sayASCII'; ')
  call writech(stdout,' acceptable? [yes] ')
  PULL answer
  if answer ~= '' then do
   if substr(answer,1,1) = 'N' then flags.MakeText = ~flags.MakeText
   end
  SAY ' '
  if flags.bold then writech(stdout,' NOT')
  writech(stdout,bolditalic'; ')
  call writech(stdout,' acceptable? [yes] ')
  PULL answer
  if answer ~= '' then do
   if substr(answer,1,1) = 'N' then flags.bold = ~flags.bold
   end
  SAY ' '
  if ~flags.verbose then writech(stdout,' minimal')
  else writech(stdout,' verbose')
  writech(stdout,progress'; ')
  call writech(stdout,' acceptable? [yes] ')
  PULL answer
  if answer ~= '' then do
   if substr(answer,1,1) = 'N' then flags.verbose = ~flags.verbose
   end
  if flags.DoPictures then do
   SAY ' '
   SAY '+-----------------------------------------------------------------+'
   SAY '| NOTE: changing Thumbnail max dim or Thumbnail format will force |'
   SAY '|       regeneration of all Thumbnail pictures. Just so you know! |'
   SAY '+-----------------------------------------------------------------+'
   SAY '|       If Thumbnail format is changed, Picture Albums must then  |'
   SAY '|       be manually edited to reflect the new Thumbnail suffixes. |'
   SAY '+-----------------------------------------------------------------+'
   SAY ' '
   svThumbnail = flags.Thumbnail
   call writech(stdout,' Thumbnail max dim = ['flags.Thumbnail'] ')
   PULL flags.Thumbnail
   if ~IsNumeric(flags.Thumbnail) then flags.Thumbnail = svThumbnail
   if flags.Thumbnail < 100 then flags.Thumbnail = 100
   SAY ' '
   svThumbformat = flags.Thmbfmt
   call writech(stdout,' Thumbnail format = ['flags.Thmbfmt'] ')
   PULL flags.Thmbfmt
   if flags.Thmbfmt ~= 'GIF' & flags.Thmbfmt ~= 'JPEG' then flags.Thmbfmt = ''
   if flags.Thmbfmt = '' then flags.Thmbfmt = svThumbformat
   end
  SAY ' '
  end

 SAY '                             [4m      [24m'
 SAY '  [1mchoices[22m:   Note:  pressing [7mRETURN[27m accepts [[3mvalue[23m]'
 SAY '  [4m      [24m'
 SAY '  [7m Quit [27m  '
 SAY '    [4m   [24m'
 SAY '    [7m ? [27m     [1mabout[22m [3mScion2html.rexx[23m; also can [1mchange the settings shown above[22m.'
 SAY ' [4m        [24m                                     [4m'substr(blanks,1,length(DBNAME)+2)'[24m'
 SAY ' [7m Normal [27m   [re]make HTMLs for all persons in [7m 'DBNAME' [27m data base {'TOTALIRN'}'
 SAY '    [4m   [24m'
 SAY '    [7m # [27m     [re]make HTMLs for a specific person: {[1m 1 .. 'TOTALIRN' [22m}'
 SAY ' [4m         [24m'
 SAY ' [7m Anchors [27m  hints for: [4m<A href="?">'DBNAME'</A>[24m'
 SAY ' '

 SAY ' '
 flags.target = 'Normal'
 call writech(stdout,'['flags.target'] ')

 PULL flags.target

 if length(flags.target) > 1 & substr(flags.target,1,1) = ' ' then flags.target = substr(flags.target,2,length(flags.target))
 if length(flags.target) > 7 then flags.target = substr(flags.target,1,7)
 if flags.target = '' then flags.target = 'Normal'
 if substr(flags.target,1,1) = '#' then do
  flags.target = ''
  SAY ' '                                    /* :) :) :) :) :) */
  SAY '     NOT #! an actual [1mnumber[22m, like, you know, from the set [7m{ 1 .. 'TOTALIRN' }[27m'
  end
 if flags.target = 'INFO' | flags.target = 'ABOUT' | flags.target = 'HELP' then flags.target = '?'
 if IsNumeric(flags.target) then do
  if flags.target > TOTALIRN | flags.target < 1 then do
    SAY ' '
    SAY '     Lousy shooting:'
    SAY ' [1m'flags.target'[22m is outside range of [7m{ 1 .. 'TOTALIRN' }[27m of persons in data base [7m 'DBNAME' [27m'
    SAY '     Clean your display, rinse your lenses, and try again!'
    flags.target = ''
   end
  end
 flags.target = Upper(strip(flags.target,,'"'))	/* just in case, remove errant quotes */
 end

if ~Validtarget(flags.target) then PauseExit()

if substr(flags.target,1,1) = 'A' then flags.target = 'ANCHORS'
if substr(flags.target,1,1) = 'N' then flags.target = 'NORMAL'
if substr(flags.target,1,1) = 'T' then flags.target = 'TEST'
if substr(flags.target,1,1) = 'Q' then flags.target = 'QUIT'
if substr(flags.target,1,1) = 'R' then	/* create Scion2html.readme */
 if Open('Scionreadme','ram:Scion2html.readme','w') then do
  Open('Scion','rexx:Scion2html.rexx','r')
  readme = 0
  readmestring = '======================README======================'
  DO While ~EOF('Scion')
   line = ReadLn('Scion')
   if readme then do
    if line = readmestring then PauseExit()
    WriteLn('Scionreadme',line)
    end
   if line = readmestring then readme = ~readme
   end
  end
 else flags.target = 'QUIT'

/* SAY flags.target */

'GETPROGVERSION'
VERSION = RESULT

if VERSION < 4.07 then do
 SAY ' '
 say 'ERROR: Requires Scion VERSION = 4.07 (or greater)'
 AskExit()
 end
else do
 if exists("sys:utilities/multiview") then
  flags.VIEWER = "sys:utilities/multiview"	/* Guide picture viewer	*/
 else do
  if VERSION < 4.09 then flags.VIEWER = "display"
  else do
   'GETVIEWER'
   flags.VIEWER = RESULT
   end
  end
/* say 'Guide picture viewer = 'flags.VIEWER */
 end

/* Get path to database so can locate any note files in same location */
'GETDBPATH'		/* new in Scion V 4.07 */
DBPATH = RESULT
DBPATH = CheckPathName(DBPATH)

/*
SAY ' '
Say ' Testing: is data base assignment of 'DBPATH||DBNAME' visible?'
SAY ' '
*/

PRAGMA('w','n')
if ~Exists(DBPATH||DBNAME) then do
 SAY 'ERROR: Scion data base 'DBNAME' not found in: 'DBPATH
 AskExit()
 end

if ~GoodScion2html then do
 Mdir = ''			/* where to put the directories? */
 if Exists(DBNAME'G') then do	/* check current path */
  Mdir = PRAGMA('d')		/* we're already there */
  end
 else do
  Tdir = "RAM:"				/* RAM: */
  if Exists('Work:') then Tdir = "Work:"	/* assume Work: */
  SAY ' '				/* ask, with default prompted */
  if flags.target ~= 'ANCHORS' then call writech(stdout,'Generate ')
  call writech(stdout,'Directory 'DBNAME'G for HTML pages ')
  if flags.target = 'ANCHORS' then call writech(stdout,'is ')
  call writech(stdout,'in: ['Tdir'] ')
  PULL Mdir
  if Mdir = '' then Mdir = Tdir		/* default was accepted */
  end
 end

Mdir = CheckPathName(Mdir)

PRAGMA('w','w')

Gdir = Mdir||DBNAME'G'
Tdir = ''
if flags.MakeText then Tdir = Mdir||DBNAME'T'
if flags.MakeGuide then Adir = Mdir||DBNAME'A'

flags.RemakeThumb = ( origThumbnail ~= flags.Thumbnail ) | ( origThumbformat ~= flags.Thmbfmt )

Open('Scion2html','S:Scion2html.Config','w')
call writeln('Scion2html',Mdir)
call writeln('Scion2html',flags.Thumbnail)
call writeln('Scion2html',flags.Thmbfmt)
call writeln('Scion2html',flags.MakeText + 2 * flags.bold + 4 * flags.MakeGuide)
if flags.GenPrefix ~= 'GENEAFI' then call writeln('Scion2html',flags.GenPrefix)
Close('Scion2html')

if flags.target = 'QUIT' then PauseExit()

if ~flags.bold then do
 flags.htmlb = '<B>'
 flags.htmlub = '</B>'
 flags.htmli = '<I>'
 flags.htmlui = '</I>'
 end
else do
 flags.htmlb = ''
 flags.htmlub = ''
 flags.htmli = ''
 flags.htmlui = ''
 end

if flags.target ~= "ANCHORS" then do
 if ~Makedir(Gdir) then do
  SAY ' '
  SAY 'ERROR: unable to create directory: 'Gdir
  AskExit()
  end

 if Tdir ~= '' then do
  if ~Makedir(Tdir) then do
   SAY ' '
   SAY 'ERROR: unable to create directory: 'Tdir
   AskExit()
   end
  end

 if flags.MakeGuide then do
  if ~Makedir(Adir) then do
   SAY ' '
   SAY 'ERROR: unable to create directory: 'Adir
   AskExit()
   end
  end
/*
 Say "Number of people in database " DBNAME " = " TOTALIRN
 SAY ' '
*/
 end

starttime = Time('e')

do i = 1 to TOTALIRN
 person.gotten.i = 0	/* no persons have yet been gotten from "DBNAME" */
 end

/* S:Scion2html.Config was here */

if IsNumeric(flags.target) then do

 GetPerComp(flags.target) /* GetPerComp gets basic info into person. array */

 pnumb = flags.target

/*
 call writech(stdout,'HTMLs for: 'person.GETFULLNAME.pnumb'? ['yes'] ')
 PULL answer
 if answer = '' then answer = 'YES'
 if substr(answer,1,1) ~= 'Y' then AskExit()
*/
 call writech(stdout,'         HTMLs')
 if flags.MakeGuide then
  call writech(stdout,' & guides')
 if flags.MakeText then
  call writech(stdout,' & ASCIItextfile')
 call writeln(stdout,' for: 'person.GETFULLNAME.pnumb)

 starttime = Time('e')

 if flags.target <= TOTALIRN then do
/*
  Say 'Processing person ' flags.target ' of ' TOTALIRN ' in database ' DBNAME
*/
  if Tdir ~= '' then Open('GenealogyText',Tdir'/G'flags.target,'w')
  flags.verbose = 1
  CALL MakeOne(flags.target)
  if Tdir ~= '' then Close('GenealogyText')
  end
 end

else do

 flags.target = Upper(flags.target)

 if flags.target = "TEST" then do
  flags.verbose = 1
  DO i = 1 TO 7
  if flags.MakeText then Open('GenealogyText',Tdir'/G'i,'w')
/*  if flags.MakeGuide then Open('GenealogyPG',Adir'/G'i'.guide,'w') */
  CALL MakeOne(i)
/*  if flags.MakeGuide then Close('GenealogyPG') */
  if flags.MakeText then Close('GenealogyText')
   end
  end

 else if flags.target ~= "ANCHORS" then do

  flags.target = 'NORMAL'
  Say ' '
  call writech(stdout,' HTMLs')
  if flags.MakeGuide then
   call writech(stdout,' & guides')
  if flags.MakeText then
   call writech(stdout,' & ASCIItextfile')
  call writeln(stdout,' for all ' TOTALIRN ' persons in database ' DBNAME)

/* GENEAFIL.htm is a Scion data base IRN order list of all persons in 
   HTML format: person * birthdate + deathdate (()) father & mother */

  Say ' '
  Say 'file name: 'Gdir'/'flags.GenPrefix'L.htm for: List of Persons.'

  Open('GenealogyFile',Gdir'/'flags.GenPrefix'L.htm','w')
  WriteLn('GenealogyFile','<HTML>')
  WriteLn('GenealogyFile','<TITLE>List of Persons.</TITLE>')
  WriteLn('GenealogyFile','<H2>List of Persons in data base "'DBNAME'". 'flags.htmlb''Time()' - 'Date()''flags.htmlub'</H2>')
  WriteLn('GenealogyFile','<H3>')

  if flags.MakeGuide then do
   Say ' '
   Say 'file name: 'Adir'/'flags.GenPrefix'L.guide for: List of Persons.'
   Open('GenealogyGuide',Adir'/'flags.GenPrefix'L.guide','w')
   WriteLn('GenealogyGuide','@database "'flags.GenPrefix'L.guide"')
   WriteLn('GenealogyGuide','@NODE Main "'DBNAME' Genealogy"')
   WriteLn('GenealogyGuide',' ')
   WriteLn('GenealogyGuide','List of Persons in data base "'DBNAME'". @{b}'Time()' - 'Date()'@{ub}')
   WriteLn('GenealogyGuide',' ')
   end

  if flags.MakeText then do
   Open('GenealogyText',Tdir'/GenealogyOf'DBNAME,'w')
   WriteLn('GenealogyText','Genealogy Data Base "'GetLastName(DBNAME)'"')
   end

  DO i = 1 TO TOTALIRN
   CALL MakeOne(i)
   end

  if flags.MakeGuide then do
   WriteLn('GenealogyGuide','_______________________________________________')
   WriteLn('GenealogyGuide','')
   WriteCh('GenealogyGuide','Definitions: ')
   if ~flags.bold then
    WriteCh('GenealogyGuide','@{b}bold=male@{ub}, @{i}italic=fem@{ui},')
   WriteLn('GenealogyGuide',' * birth, + death,  more info')
   WriteLn('GenealogyGuide','_______________________________________________')
   WriteLn('GenealogyGuide','')
   WriteCh('GenealogyGuide','Credits: ')
   WriteCh('GenealogyGuide','(@{i}AMIGA@{ui})  ')
   WriteCh('GenealogyGuide','(Scion  @{b}Robbie J Akins@{ub})  ')
   WriteLn('GenealogyGuide','(Scion2html.rexx  @{b}Harold Ipolyi)')
   WriteLn('GenealogyGuide','@ENDNODE')
   Close('GenealogyGuide')
   end

  WriteCh('GenealogyFile','</H3>')
  WriteCh('GenealogyFile','<HR>')
  WriteLn('GenealogyFile','<Address>')
  WriteCh('GenealogyFile','Definitions: ')
  if ~flags.bold then
   WriteCh('GenealogyFile',flags.htmlb'bold=male'flags.htmlub', 'flags.htmli'italic=fem'flags.htmlui',')
  WriteLn('GenealogyFile',' * birth, + death,  more info,  picture album')
  WriteCh('GenealogyFile','<HR>Credits: ')
  WriteCh('GenealogyFile','('flags.htmli'<A href="http://www.omnipresence.com/')
  WriteLn('GenealogyFile','amiga/">AMIGA</A>'flags.htmlui')  ')
  'GETPROGVERSION'
  VERSION = RESULT
  WriteCh('GenealogyFile','(<A href="http://wuarchive.wustl.edu/pub/aminet/')
  WriteCh('GenealogyFile','info/www/dirs/')
  WriteCh('GenealogyFile','biz_dbase.html">'flags.htmlb'Scion')
  if VERSION > 0 then WriteCh('GenealogyFile','V'VERSION)
  WriteLn('GenealogyFile',''flags.htmlub'</A>  'flags.htmlb'Robbie J Akins'flags.htmlub')  ')
  WriteCh('GenealogyFile','(<A href="http://wuarchive.wustl.edu/pub/aminet/')
  WriteCh('GenealogyFile','info/www/dirs/gfx_co')
  WriteLn('GenealogyFile','nv.html">'flags.htmlb'GfxCon'flags.htmlub'</A>  'flags.htmlb'Dirk Farin'flags.htmlub')  ')
  WriteCh('GenealogyFile','(<A href="http://wuarchive.wustl.edu/pub/aminet/')
  WriteCh('GenealogyFile','info/www/dirs/')
  WriteCh('GenealogyFile','util_rexx.html">'flags.htmlb'Scion2html.rexx'flags.htmlub'</A>  ')
/*
  WriteCh('GenealogyFile','<A href="http://www.azstarnet.com/~dagley')
  WriteCh('GenealogyFile','/IPOLYIG/P1.htm">'flags.htmlb'Harold Ipolyi'flags.htmlub'</A>)')
*/
  WriteLn('GenealogyFile',''flags.htmlb'Harold Ipolyi'flags.htmlub')')
  WriteCh('GenealogyFile','</Address>')
  WriteLn('GenealogyFile','</HTML>')
  end

 Say ' '
 Say ' '
 Say ' If you have not already done so, add the following anchor pointing to'
 Say ' "'GetLastName(DBNAME)' Genealogy" to a HTML file (maybe HOME PAGE):  '
 Say ' '
 Say ' <A href="/'Gdir'/'flags.GenPrefix'L.htm">'GetLastName(DBNAME)' Genealogy</A>'
 Say ' '
 Say '          and maybe:'
 Say ' '

 GetPerComp(1)
 if flags.GenPrefix = "GENEAFI" then
  Say ' <A href="/'Gdir'/P1.htm">'person.GETFULLNAME.1'</A>'
 else
  Say ' <A href="/'Gdir'/'flags.GenPrefix'P1.htm">'person.GETFULLNAME.1'</A>'
 Say ' '
  end

/*
 Open('CreditsFile','ram:Credits.html','w')
*/

 elapsedtime =  Time('e') - starttime

 spacer = substr(blanks,1,Length(elapsedtime))

 Say ' '
 Say ' [7m                                       'spacer'         [27m'
 Say ' [7m Scion2html.rexx completed normally in 'elapsedtime' seconds [27m'
 Say ' [7m                                       'spacer'         [27m'

 AskExit()

 EXIT	/* redundant */

/*************************************************************************
*                                                                        *
*  Makeone procedure extracts data and creates page for a single person  *
*                                                                        *
*************************************************************************/

MakeOne: PROCEDURE EXPOSE person. flags. DBPATH DBNAME Adir Gdir Tdir
 PARSE ARG ScionIRN

'EXISTPERSON' ScionIRN
if RESULT = 'YES' then do

 if flags.GenPrefix = "GENEAFI" then do
  PersonPrefix = "P"			/* Person file name prefix */
  FamilyPrefix = "F"			/* Family file name prefix */
  end
 else do
  PersonPrefix = flags.GenPrefix"P"	/* Person file name prefix */
  FamilyPrefix = flags.GenPrefix"F"	/* Family file name prefix */
  end

 if FamilyPrefix = PersonPrefix then do
  say ' FamilyPrefix MUST NOT EQUAL PersonPrefix'
  say ' 'FamilyPrefix'                           'PersonPrefix
  AskExit()
  EXIT
  end

 HasFileFATHER = 0
 HasFileMOTHER = 0
 HasMOTHER = 0
 HasFATHER = 0
 HasPARENTS = 0
 HasCHILDREN = 0
 DoGenText = 0
 'GETPARENTS' ScionIRN
 PARENTS = RESULT
 tPARENTSt = 't'PARENTS't'
/* Say 'PARENTS = 'PARENTS tPARENTSt	??? EXISTPARENTS IRN ??? */
 if tPARENTSt ~= 'tt' then HasPARENTS = 1
 'GETMARRIAGE' ScionIRN 0	/*      ??? GETTOTMARRIAGES IRN ???     */
 MARRIAGE = RESULT
 tMARRIAGESt = 't'MARRIAGE't'
/*	Say 'MARRIAGES = 'MARRIAGE tMARRIAGESt		*/
 if tMARRIAGESt ~= 'tMARRIAGEt' then do
  mFGRN = MARRIAGE
  'GETNUMCHILD' mFGRN
  if RESULT > 0 then HasCHILDREN = 1
 end
/*
Say 'PARENTS = 'PARENTS tPARENTSt 'MARRIAGES = 'MARRIAGES tMARRIAGESt 'HasPARENTS = 'HasPARENTS 'HasCHILDREN = 'HasCHILDREN
*/
 if flags.MakeText & ( HasPARENTS + HasCHILDREN ) = 1 then doGenText = 1

 GetPerComp(ScionIRN)

 'GETBAPTISMDATE' ScionIRN
 BAPTISMDATE = RESULT
 'GETRELIGION' ScionIRN
 RELIGION = RESULT
 'GETBAPTISMPLACE' ScionIRN
 BAPTISMPLACE = RESULT
 'GETBURIALPLACE' ScionIRN
 BURIALPLACE = RESULT
 'GETDIEDOF' ScionIRN
 DIEDOF = RESULT
 'GETEDUCATION' ScionIRN
 EDUCATION = RESULT
 'GETOCCUPATION' ScionIRN
 OCCUPATION = RESULT
 'GETPERSCOMMENT' ScionIRN
 PERSCOMMENT = RESULT
 'GETPERSREFS' ScionIRN
 PERSREFS = RESULT
/*
 ValidInfo = 0
 if LASTNAME||BIRTHDATE||BIRTHPLACE||DEATHDATE||DEATHPLACE||BURIALPLACE||RELIGION||DIEDOF||EDUCATION||OCCUPATION||PERSCOMMENT||PERSREFS ~= "" THEN ValidInfo = 1
 if ~ValidInfo then do
Say "Person " ScionIRN"'s lacking information; no new HTML file being created!"
  return
  end
 if flags.MakeText & ( ValidInfo | LASTNAME ~= "" ) then DoGenText = 1
*/
 if flags.MakeText then DoGenText = 1
 PfilN = PersonPrefix || ScionIRN

 dPfilN = Gdir'/'PfilN
 gPfilN = Adir'/'PfilN
 if flags.verbose then do
  Say ''
  Say ' HTML: [7m 'dPfilN'.htm [27m for: 'person.GETFULLNAME.ScionIRN' {'ScionIRN'}'
  end
 else Say person.GETFULLNAME.ScionIRN' {'ScionIRN'}'
 Open('PERSONFILE',dPfilN'.htm','w')
 WriteLn('PERSONFILE','<HTML>')
 WriteLn('PERSONFILE','<TITLE>'person.GETFULLNAME.ScionIRN' Data Sheet</TITLE>')
 WriteLn('PERSONFILE','<PRE><TT>')

 if flags.MakeGuide then do
  if flags.verbose then 
   Say 'Guide: [7m 'gPfilN'.guide [27m for: 'person.GETFULLNAME.ScionIRN' {'ScionIRN'}'
  Open('PERSONGuide',gPfilN'.guide','w')
  WriteLn('PERSONGuide','@database "'gPfilN'.guide"')
  WriteLn('PERSONGuide','@NODE Main "'person.GETFULLNAME.ScionIRN' Genealogy"')
  WriteCh('PERSONGuide',person.GETFULLNAME.ScionIRN)
  end

 if Exists(DBPATH'PP'ScionIRN'.'DBNAME) & flags.DoPictures then do
  if flags.RemakeThumb then do
   DELETE(dPfilN'.GIF')
   DELETE(dPfilN'.JPEG')
   end

  if AgeTest(DBPATH'PP'ScionIRN'.'DBNAME, dPfilN'.jpg') then do
   Delete(dPfilN'.'flags.Thmbfmt)
   end

  WriteCh('PERSONFILE','   <A HREF="'PfilN'A.htm')
  WriteLn('PERSONFILE','"><img src="'PfilN'.'flags.Thmbfmt'"></A>')
  end

 WriteCh('PERSONFILE',person.MGETFULLNAME.ScionIRN)

 if Exists(DBPATH'PN'ScionIRN'.'DBNAME) then do
  if flags.verbose then Say 'Writing info  file 'dPfilN'I.htm'
  Open('PNDBNAME',DBPATH'PN'ScionIRN'.'DBNAME,'r')
  Open('PERSONI',dPfilN'I.htm','w')
  if flags.MakeGuide then do
   Open('PERSONGI',gPfilN'I.guide','w')
   WriteLn('PERSONGI','@database "'gPfilN'I.guide"')
   WriteLn('PERSONGI','@NODE Main "'person.GETFULLNAME.ScionIRN' Information."')
   end
  WriteLn('PERSONI','<HTML>')
  WriteLn('PERSONI','<TITLE>'person.GETFULLNAME.ScionIRN' Information</TITLE>')
  WriteCh('PERSONI','<A HREF="'PfilN'.htm">'person.MGETFULLNAME.ScionIRN)
  WriteCh('PERSONI','</A> Information. (<A HREF="'flags.GenPrefix'L.htm">')
  WriteLn('PERSONI',''flags.htmlb'List of persons.'flags.htmlub'</A>)<PRE><TT>')
  if DoGenText then WriteLn('GenealogyText',person.PGETFULLNAME.ScionIRN' Information.')
  DO While ~EOF('PNDBNAME')
   line = ReadLn('PNDBNAME')
   WriteLn('PERSONI',CheckForReplacement(line))
   if flags.MakeGuide then WriteLn('PERSONGI',CheckGuideRepl(line))
   if DoGenText then WriteLn('GenealogyText',CheckForNAReplacement(line))
   end
  Close('PNDBNAME')
  if DoGenText then WriteLn('GenealogyText','')
  WriteLn('PERSONI','</HTML>')
  Close('PERSONI')
  if flags.MakeGuide then do
   WriteLn('PERSONGI','@ENDNODE')
   Close('PERSONGI')
   end
  WriteCh('PERSONFILE',' (<A HREF="'PfilN'I.htm">  </A>)')
  if flags.MakeGuide then
   WriteCh('PERSONGuide',' @{" More Info () " LINK 'gPfilN'I.guide/Main}')   
  end

 if Exists(DBPATH'PP'ScionIRN'.'DBNAME) then do
  if flags.MakeGuide then do
   WriteCh('PERSONGuide',' @{" Picture () " RXS "address command ')
   WriteCh('PERSONGuide',"'"flags.VIEWER" ")
   WriteCh('PERSONGuide',DBPATH'PP'ScionIRN'.'DBNAME"'"'"')
   WriteCh('PERSONGuide','}')
   end

  if flags.DoPictures then do
   if ~Exists(dPfilN'.jpg') then do
    Say 'Creating picture 'dPfilN'.jpg'
/*
Say 'Sys:Tools/GfxCon 'DBPATH'PP'ScionIRN'.'DBNAME' TO 'dPfilN'.jpg FORMAT JPEG QUALITY 100'
*/
Say 'Sys:Tools/GfxCon 'DBPATH'PP'ScionIRN'.'DBNAME' TO 'dPfilN'.jpg FORMAT JPEG QUALITY 100'
OldStackSize = pragma('s',21000)
address command 'Sys:Tools/GfxCon 'DBPATH'PP'ScionIRN'.'DBNAME' TO 'dPfilN'.jpg FORMAT JPEG QUALITY 100'
call pragma('s',OldStackSize)
    end
   if Exists(dPfilN'.'flags.Thmbfmt) then do
    if flags.verbose then Say '  ~ image 'dPfilN'.'flags.Thmbfmt'  ...OK... '
    end
   else do
    if flags.verbose then Say 'Creating image 'dPfilN'.'flags.Thmbfmt
/*
Say 'Sys:Tools/GfxCon 'DBPATH'PP'ScionIRN'.'DBNAME' TO 'dPfilN'.'flags.Thmbfmt' FORMAT 'flags.Thmbfmt' BOXFIT 'flags.Thumbnail' 'flags.Thumbnail
*/
Say 'Sys:Tools/GfxCon 'DBPATH'PP'ScionIRN'.'DBNAME' TO 'dPfilN'.'flags.Thmbfmt' FORMAT 'flags.Thmbfmt' BOXFIT 'flags.Thumbnail' 'flags.Thumbnail
OldStackSize = pragma('s',21000)
address command 'Sys:Tools/GfxCon 'DBPATH'PP'ScionIRN'.'DBNAME' TO 'dPfilN'.'flags.Thmbfmt' FORMAT 'flags.Thmbfmt' BOXFIT 'flags.Thumbnail' 'flags.Thumbnail
call pragma('s',OldStackSize)
    end                   
WriteCh('PERSONFILE',' (<A HREF="'PfilN'A.htm">'flags.htmlb'  'flags.htmlub'</A>)')
   if Exists(dPfilN'A.htm') then do
    if flags.verbose then Say '  ~ picture album 'dPfilN'A.htm  ...OK... '
    end
   else do
    Say 'Creating picture album  'dPfilN'A.htm'
    Open('PERSONP',dPfilN'A.htm','w')
    WriteLn('PERSONP','<HTML>')
    WriteLn('PERSONP','<TITLE>'person.GETFULLNAME.ScionIRN' Picture Album</TITLE>')
    WriteCh('PERSONP',person.MGETFULLNAME.ScionIRN' . ')
    WriteCh('PERSONP','<A HREF="'PfilN'.jpg">')
    WriteLn('PERSONP','<img src="'PfilN'.'flags.Thmbfmt'"></A>')
    WriteLn('PERSONP',' . 'flags.htmlb'Picture Album'flags.htmlub'<HR><pre><tt>')
    WriteCh('PERSONP','<H3>another JPEG picture <A HREF="'PfilN'A1.jpg">')
    WriteCh('PERSONP','<img src="'PfilN'A1.'flags.Thmbfmt'"></A> anchored by ')
    WriteLn('PERSONP','thumbnail image created by:')
    WriteCh('PERSONP','GfxCon 'dPfilN'A1.jpg TO 'dPfilN'A1.'flags.Thmbfmt' FORMAT ')
    WriteCh('PERSONP',flags.Thmbfmt' BOXFIT 'flags.Thumbnail' 'flags.Thumbnail)
    WriteLn('PERSONP','<HR></pre></tt>')
    WriteLn('PERSONP',''flags.htmlb'Edit'flags.htmlub' 'dPfilN'A.htm 'flags.htmlb'to add more pictures to the Picture Album<P>')
    WriteCH('PERSONP','CAUTION: deleting Directory:'flags.htmlub' 'Gdir' 'flags.htmlb'destroys all Picture ')
    WriteLn('PERSONP',' Album modifications. YOUR WORK WILL BE LOST!'flags.htmlub'')
    WriteLn('PERSONP','</HTML>')
    Close('PERSONP')
    end
   end
  end

 WriteLn('PERSONFILE',' (<A HREF="'flags.GenPrefix'L.htm">'flags.htmlb'List of persons.'flags.htmlub'</A>)')

 if flags.MakeGuide then do
  WriteLn('PERSONGuide',' @{" List of People " LINK 'Adir'/'flags.GenPrefix'L.guide/Main}')
  end

 if DoGenText then do
  if flags.target ~= "NORMAL" then
   Say 'ASCII: [7m 'Tdir'/G'ScionIRN' [27m for 'person.GETFULLNAME.ScionIRN' {'ScionIRN'}'
  WriteLn('GenealogyText','')
  WriteLn('GenealogyText','-----------------------------------------------------------')
  WriteLn('GenealogyText','')
  WriteLn('GenealogyText',person.PGETFULLNAME.ScionIRN' Data Sheet')
  end
 if person.GETBIRTHDATE.ScionIRN || person.GETBIRTHPLACE.ScionIRN ~= "" then do
  if person.GETBIRTHDATE.ScionIRN ~= "" then
   PersOutputCh('Born: 'person.GETBIRTHDATE.ScionIRN' * ',0)
  if person.GETBIRTHPLACE.ScionIRN ~= "" then
   PersOutputCh(person.GETBIRTHPLACE.ScionIRN,0)
  PersOutputCr()
  end
 if BAPTISMDATE || BAPTISMPLACE || RELIGION ~= "" then do
  PersOutputCh('Baptised: ')
  PersOutputCh(BAPTISMDATE' ')
  if RELIGION ~= "" then PersOutputCh('{'RELIGION'} ',0)
  if BAPTISMPLACE ~= "" then PersOutputCh(BAPTISMPLACE,0)
  PersOutputCr()
  end
 if person.GETDEATHDATE.ScionIRN ~= "" & person.GETDEATHDATE.ScionIRN ~= "dead" then do
  PersOutputCh('Died: 'person.GETDEATHDATE.ScionIRN,0)
  if person.GETDEATHPLACE.ScionIRN ~= "" then
   PersOutputCh(' + 'person.GETDEATHPLACE.ScionIRN,0)
  if BURIALPLACE ~= "" then PersOutputCh(' . Buried: 'BURIALPLACE,0)
  PersOutputCr()
  end
 else do
  if person.GETDEATHPLACE.ScionIRN ~= "" then
   PersOutputLn(person.GETDEATHPLACE.ScionIRN,1)
  if BURIALPLACE ~= "" then PersOutputLn(BURIALPLACE,1)
  end
 if DIEDOF ~= "" then PersOutputLn('Cause of Death: 'DIEDOF,1)
 if EDUCATION ~= "" then PersOutputLn('Education: 'EDUCATION,1)
 if OCCUPATION ~= "" then PersOutputLn('Occupation: 'OCCUPATION,1)
 if PERSCOMMENT ~= "" then PersOutputLn('Comments: 'PERSCOMMENT,1)
 if PERSREFS ~= "" then PersOutputLn('References: 'PERSREFS,1)

/* end of personal data; start family tree segment */

 PersOutputHL()
 HeadLine = ''
 if HasPARENTS then HeadLine = HeadLine' Parents '
 'GETNUMSIB' ScionIRN
 xtra = ''
 if RESULT > 1 then xtra = 's'
 if RESULT > 0 then HeadLine = HeadLine' Sibling'xtra' '
 'GETNUMMARRY' ScionIRN
 xtra = ''
 if RESULT > 1 then xtra = 's'
 if RESULT > 0 then HeadLine = HeadLine' Spouse'xtra' '
 'GETTOTALCHILD' ScionIRN
 xtra = 'Child'
 if RESULT > 1 then xtra = xtra'ren'
 if RESULT > 0 then HeadLine = HeadLine' 'xtra
 PersOutputLn('Immediate Family: 'HeadLine,0)
 if DoGenText then WriteLn('GenealogyText','')
 if HasPARENTS then do
  'GETPRINCIPAL' PARENTS
  PRINCIPAL = RESULT
  'GETSPOUSE' PARENTS
  SPOUSE = RESULT
  'GETMARRYDATE' PARENTS
  PARENTSMARRIAGEDATE = RESULT
  'GETMARRYPLACE' PARENTS
  PARENTSmFGRNPLACE = RESULT
  'GETSEX' PRINCIPAL
  if RESULT = 'M' then do
   FATHERIRN = PRINCIPAL
   MOTHERIRN = SPOUSE
   end
  else do
   FATHERIRN = SPOUSE
   MOTHERIRN = PRINCIPAL
   end
  GetPerComp(FATHERIRN)
  if person.GETFIRSTNAME.FATHERIRN||person.GETLASTNAME.FATHERIRN ~= "" then
   HasFATHER = 1
  GetPerComp(MOTHERIRN)
  if person.GETFIRSTNAME.MOTHERIRN||person.GETLASTNAME.MOTHERIRN ~= "" then
   HasMOTHER = 1

  if FATHERLASTNAME ~= "" then do
   HasFileFATHER = 1
   FATHERFILENAME = PersonPrefix || FATHERIRN
   end

  if MOTHERLASTNAME ~= "" then do
   HasFileMOTHER = 1
   MOTHERFILENAME = PersonPrefix || MOTHERIRN
   end

  if HasFileFATHER then do
   PersOutputCh('  <'FATHERIRN'>',1)
   PersOutputCh(' & ',0)
   end
  PersOutputCh('<'MOTHERIRN'>',1)
  if PARENTSMARRIAGEDATE ~= "" then PersOutputCh(' & 'PARENTSMARRIAGEDATE,0)
  if PARENTSmFGRNPLACE ~= "" then PersOutputCh(' @ 'PARENTSmFGRNPLACE,0)
  PersOutputCr()
  spcs = '  |'
  DO i = 0 TO Length(FATHERFULLNAME) /* ################ */
   spcs = spcs' '	 /* ??? GETFAMLBL1 ??? */
  end   		 /* ??? GETFAMLBL2 ??? */

 Minfo = Exists(DBPATH'FN'PARENTS'.'DBNAME)
 if PARENTSmFGRNCELEBRANT ~= '' | Minfo then do
  if DoGenText then WriteLn('GenealogyText','  |')   
  'GETNUMCHILD' PARENTS
  TOTCHILDREN = RESULT
/* say 'TOTCHILDREN = 'TOTCHILDREN */
  DO i = 0 TO TOTCHILDREN - 1
   'GETCHILD' PARENTS i
   PARENTSc = RESULT
   GetPerComp(PARENTSc)
   if person.GETFIRSTNAME.PARENTSc ~= "" then do
    if PARENTSc ~= ScionIRN then do
     LastNameFl = 1
     if person.GETLASTNAME.PARENTSc = person.GETLASTNAME.FATHERIRN then do
      LastNameFl = -1
      LastNameVal = person.GETLASTNAME.FATHERIRN
      end
     PersOutputCh('  |_',0)
     PersOutputCh('<'PARENTSc'>',LastNameFl)
     LastNameFl = 1
     BirthDeath(PARENTSc)
     PersOutputCr()
     end
    end
   end
  end
  PersOutputLn('  |',0)
 END

/* end of parents, siblings segment; start marriages segment */

vert.0 = ''
vert.1 = '|'
'GETNUMMARRY' ScionIRN
TOTMARRIAGES = RESULT
/* say 'TOTMARRIAGES = 'TOTMARRIAGES */
DO i = 0 TO TOTMARRIAGES
 'GETMARRIAGE' ScionIRN i
 MARRIAGE = RESULT               /* use: 'EXISTFAMILY'   */
 if MARRIAGE > -1 then do
  MARRIAGES = i
  j = i + 1
  vert.j = vert.1||vert.i
  end
 end
tMARRIAGESt = 't'MARRIAGES't'
 PersOutputCh('  |_',0) 
 if tMARRIAGESt ~= 'tMARRIAGESt' then do
  DO i = 0 TO MARRIAGES
   'GETMARRIAGE' ScionIRN i
   mFGRN = RESULT
   if mFGRN ~= "" then do
    ki = MARRIAGES - i + 1
    if ki ~= MARRIAGES + 1 then PersOutputLn('    'vert.ki,0)
    j = MARRIAGES + 1 - i
    'GETSPOUSE' mFGRN
    SPOUSE = RESULT
    if SPOUSE = ScionIRN then do
     'GETPRINCIPAL' mFGRN
     SPOUSE = RESULT
     end
    'GETMARRYDATE' mFGRN
    MARRIAGEDATE = RESULT
    'GETMARRYPLACE' mFGRN
    mFGRNPLACE = RESULT

    SPOUSEFILENAME = PersonPrefix || SPOUSE

    if i = 0 then do
     PersOutputCh('<'ScionIRN'> & ',1)
     PersOutputCh('<'SPOUSE'>',1)
     end

    else do
     PersOutputCh('    'vert.j'_&',0)
     PersOutputCh('<'SPOUSE'>',1)
     end

    if MARRIAGEDATE ~= "" then PersOutputCh(' & 'MARRIAGEDATE,0)
    if mFGRNPLACE ~= "" then PersOutputCh(' @ 'mFGRNPLACE,0)
    PersOutputCr()
    jk = MARRIAGES - i
    spcs = '    'vert.jk'    |'

    FfilN = Gdir'/'FamilyPrefix || mFGRN
    Minfo = 0
    if Exists(DBPATH'FN'mFGRN'.'DBNAME) then do
     Minfo = 1

     if AgeTest(DBPATH'FN'mFGRN'.'DBNAME,FfilN'I.htm') then do
      Say 'Writing info  file 'FfilN'I.htm'
      Open('FNDBNAME',DBPATH'FN'mFGRN'.'DBNAME,'r')
      Open('FAMILYI',FfilN'I.htm','w')
      WriteLn('FAMILYI','<HTML>')
      WriteCh('FAMILYI','<TITLE>'person.MGETFULLNAME.ScionIRN' & ')
      WriteLn('FAMILYI',person.MGETFULLNAME.SPOUSE' Family Information</TITLE>')

      if Exists(DBPATH'FP'mFGRN'.'DBNAME) & flags.DoPictures then do
       WriteCh('FAMILYI','<A HREF="'FamilyPrefix || mFGRN'A.htm')
       WriteCh('FAMILYI','"><img src="'FamilyPrefix || mFGRN'.'flags.Thmbfmt'"></A>')
       end

      WriteCh('FAMILYI','<H2>Family of 'person.MGETFULLNAME.ScionIRN' & ')
      WriteCh('FAMILYI',person.MGETFULLNAME.SPOUSE)

      if Exists(DBPATH'FP'mFGRN'.'DBNAME) & flags.DoPictures then do
       WriteCh('FAMILYI',' (<A HREF="'FamilyPrefix || mFGRN'A.htm')
       WriteCh('FAMILYI','">'flags.htmlb'  'flags.htmlub'</A>) ')
       end

      WriteCh('FAMILYI',' (<A HREF="'flags.GenPrefix'L.htm">')
      WriteLn('FAMILYI',''flags.htmlb'List of persons.'flags.htmlub'</A>)</H2><PRE><TT>')
      DO While ~EOF('FNDBNAME')
       line = ReadLn('FNDBNAME')
       WriteLn('FAMILYI',CheckForReplacement(line))
/*
if DoGenText then WriteLn('GenealogyText',spcs'  'CheckForNAReplacement(line))
*/
       end
      Close('FNDBNAME')
      WriteLn('FAMILYI','</HTML>')
      Close('FAMILYI')
      end
     end

    Palbum = 0
    if Exists(DBPATH'FP'mFGRN'.'DBNAME) & flags.DoPictures then do

     Palbum = 1
     if flags.RemakeThumb then do
      DELETE(FfilN'.GIF')
      DELETE(FfilN'.JPEG')
      end
     if AgeTest(DBPATH'FP'mFGRN'.'DBNAME,FfilN'.jpg') then do
      Delete(FfilN'.'flags.Thmbfmt)
      end

     if flags.DoPictures & ~Exists(FfilN'.jpg') then do
      Say 'Creating picture 'FfilN'.jpg'
/*
Say 'Sys:Tools/GfxCon 'DBPATH'FP'mFGRN'.'DBNAME' TO 'FfilN'.jpg FORMAT JPEG QUALITY 100'
*/
Say 'Sys:Tools/GfxCon 'DBPATH'FP'mFGRN'.'DBNAME' TO 'FfilN'.jpg FORMAT JPEG QUALITY 100'
OldStackSize = pragma('s',21000)
address command 'Sys:Tools/GfxCon 'DBPATH'FP'mFGRN'.'DBNAME' TO 'FfilN'.jpg FORMAT JPEG QUALITY 100'
call pragma('s',OldStackSize)
      end
     if Exists(FfilN'.'flags.Thmbfmt) then do
      if flags.verbose then Say '  ~ image 'FfilN'.'flags.Thmbfmt'  ...OK... '
      end
     else do
      if flags.verbose then Say 'Creating image 'FfilN'.'flags.Thmbfmt''
/*
Say 'Sys:Tools/GfxCon 'DBPATH'FP'mFGRN'.'DBNAME' TO 'FfilN'.'flags.Thmbfmt' FORMAT 'flags.Thmbfmt' BOXFIT 'flags.Thumbnail' 'flags.Thumbnail
*/
Say 'Sys:Tools/GfxCon 'DBPATH'FP'mFGRN'.'DBNAME' TO 'FfilN'.'flags.Thmbfmt' FORMAT 'flags.Thmbfmt' BOXFIT 'flags.Thumbnail' 'flags.Thumbnail
OldStackSize = pragma('s',21000)
address command 'Sys:Tools/GfxCon 'DBPATH'FP'mFGRN'.'DBNAME' TO 'FfilN'.'flags.Thmbfmt' FORMAT 'flags.Thmbfmt' BOXFIT 'flags.Thumbnail' 'flags.Thumbnail
call pragma('s',OldStackSize)
      end
     if Exists(FfilN'A.htm') then do
      if flags.verbose then Say '  ~ picture album 'FfilN'A.htm  ...OK... '
      end
     else do
      Say 'Creating picture album  'FfilN'A.htm'
      Open('FAMILYP',FfilN'A.htm','w')
WriteLn('FAMILYP','<HTML>')
WriteCh('FAMILYP','<TITLE>'person.MGETFULLNAME.ScionIRN' & ')
WriteCh('FAMILYP',person.MGETFULLNAME.SPOUSE)
WriteLn('FAMILYP',' Family Picture Album</TITLE>')
WriteCh('FAMILYP',person.MGETFULLNAME.ScionIRN' & ')
WriteCh('FAMILYP',person.MGETFULLNAME.SPOUSE)
WriteCh('FAMILYP',' 'flags.htmlb'Family'flags.htmlub' . ')
WriteCh('FAMILYP','<A HREF="'FamilyPrefix || mFGRN'.jpg">')
WriteCh('FAMILYP','<img src="'FamilyPrefix || mFGRN'.'flags.Thmbfmt'"></A>')
WriteLn('FAMILYP',' . 'flags.htmlb' Picture Album 'flags.htmlub'<HR><pre><tt>')
WriteCh('FAMILYP','another JPEG picture <A HREF="'FamilyPrefix || mFGRN)
WriteCh('FAMILYP','A1.jpg"><img src="')
WriteCh('FAMILYP',FamilyPrefix || mFGRN'A1.'flags.Thmbfmt'"></A> anchored by ')
WriteLn('FAMILYP','thumbnail image created by:')
WriteCh('FAMILYP','GfxCon 'FfilN'A1.jpg TO 'FfilN'A1.'flags.Thmbfmt' FORMAT ')
WriteCh('FAMILYP',flags.Thmbfmt' BOXFIT 'flags.Thumbnail' 'flags.Thumbnail)
WriteLn('FAMILYP','<HR></pre></tt>')
WriteLn('FAMILYP',''flags.htmlb'Edit'flags.htmlub' 'FfilN'A.htm 'flags.htmlb'to add more pictures to the Picture Album<P>')
WriteCH('FAMILYP','CAUTION: deleting Directory:'flags.htmlub' 'Gdir' 'flags.htmlb'destroys all Picture ')
WriteLn('FAMILYP',' Album modifications. YOUR WORK WILL BE LOST!'flags.htmlub'')
WriteLn('FAMILYP','</HTML>')
      Close('FAMILYP')
      end
     end

    if MARRIAGECELEBRANT ~= '' | Minfo | Palbum then do
     if Minfo then
      WriteCh('PERSONFILE',spcs'(<A HREF="'FamilyPrefix || mFGRN'I.htm">  </A>) ')

     if Exists(DBPATH'FP'mFGRN'.'DBNAME) & flags.DoPictures then do
      WriteCh('PERSONFILE',' (<A HREF="'FamilyPrefix || mFGRN'A.htm')
      WriteCh('PERSONFILE','">'flags.htmlb'  'flags.htmlub'</A>) ')
      end

     if Exists(DBPATH'FP'mFGRN'.'DBNAME) & flags.MakeGuide then do
      WriteCh('PERSONGuide',spcs' @{" Picture () " RXS "address command ')
      WriteCh('PERSONGuide',"'"flags.VIEWER" ")
      WriteCh('PERSONGuide',DBPATH'FP'mFGRN'.'DBNAME"'"'"')
      WriteLN('PERSONGuide','}')
      end

     if ( Exists(DBPATH'FP'mFGRN'.'DBNAME) & flags.DoPictures ) | Minfo then 
      WriteLn('PERSONFILE',' ')

     'GETCELEBRANT' mFGRN
     if RESULT ~= "" then PersOutputLn(spcs' Celebrant: 'RESULT,1)
     'GETWITNESS' mFGRN
     if RESULT ~= "" then PersOutputLn(spcs'   Witness: 'RESULT,1)
     'GETFAMCOMMENT' mFGRN
     if RESULT ~= "" then PersOutputLn(spcs'  Comments: 'RESULT,1)
     'GETENDDATE' mFGRN
     ENDDATE = RESULT
     'GETENDING' mFGRN
     ENDING = RESULT
     if ENDDATE ~= "" | ENDING > 0 then do
      PersOutputCh(spcs,0)
      PersOutputCh('     Ended: ',0)
      if ENDDATE ~= "" then PersOutputCh(ENDDATE,0)
      if ENDING = 1 then PersOutputCh('  None',0)
      if ENDING = 2 then PersOutputCh('  Divorce',0)
      if ENDING = 3 then PersOutputCh('  Separation',0)
      if ENDING = 4 then PersOutputCh('  Annulment',0)
      if ENDING = 5 then PersOutputCh('  Death',0)
      PersOutputCr()
      end

     'GETFAMREFS' mFGRN
     if RESULT ~= "" then PersOutputLn(spcs'References: 'RESULT,1)

     if DoGenText then WriteLn('GenealogyText',spcs)

     if Minfo & ( DoGenText | flags.MakeGuide ) then do
      if flags.MakeGuide then WriteLn('PERSONGuide',spcs)
      Open('FNDBNAME',DBPATH'FN'mFGRN'.'DBNAME,'r')
      DO While ~EOF('FNDBNAME')
       line = ReadLn('FNDBNAME')
       if flags.MakeGuide then WriteLn('PERSONGuide',spcs'  'CheckGuideRepl(line))
       if DoGenText then 
        WriteLn('GenealogyText',spcs'  'CheckForNAReplacement(line))
       end
      Close('FNDBNAME')
      end
     end

     'GETNUMCHILD' mFGRN
     TOTCHILDREN = RESULT
/* say 'TOTCHILDREN = 'TOTCHILDREN */
     DO k = 0 TO TOTCHILDREN - 1
      'GETCHILD' mFGRN k
      mFGRNc = RESULT

      GetPerComp(mFGRNc)

      if person.GETFIRSTNAME.mFGRNc ~= "" then do
       HasCHILDREN = 1

       jk = MARRIAGES - i
       LastNameFl = 1
       if person.GETLASTNAME.mFGRNc = person.GETLASTNAME.ScionIRN then do
        LastNameFl = -1
        LastNameVal = person.GETLASTNAME.ScionIRN
        end
       PersOutputCh('    'vert.jk'    |_<'mFGRNc'>',LastNameFl)
       LastNameFl = 1
       BirthDeath(mFGRNc)
       PersOutputCr()
       end
      end
     end
    end
  end
 else do
  LastNameFl = 1
  if LASTNAME = FATHERLASTNAME then do
  LastNameFl = -1
   LastNameVal = FATHERLASTNAME
   end
  PersOutputLn('<'ScionIRN'>',1)
  LastNameFl = 1
 end

 if HasPARENTS then do
  if flags.verbose then say ' Ancestors...'
  PersOutputHL()
  PersOutputLn('Ancestors',0)
  if DoGenText then WriteLn('GenealogyText','')
  Paternal(ScionIRN,'  ')
  PersOutputCh('<'ScionIRN'>',1)
  if person.GETBIRTHDATE.ScionIRN ~= "" then
   PersOutputCh(' * 'person.GETBIRTHDATE.ScionIRN,0)
  if person.GETDEATHDATE.ScionIRN ~= "" & person.GETDEATHDATE.ScionIRN ~= "dead" then
   PersOutputCh(' + 'person.GETDEATHDATE.ScionIRN,0)
  PersOutputCr()
  Maternal(ScionIRN,'  ')
  end

 if HasCHILDREN then do
  if flags.verbose then say ' Descendants...'
  PersOutputHL()
  indent = "  "
  PersOutputLn('Descendants',0)
  if DoGenText then WriteLn('GenealogyText','')
  PersOutputCh(indent'<'ScionIRN'>',1)
  if person.GETBIRTHDATE.ScionIRN ~= "" then
   PersOutputCh(' * 'person.GETBIRTHDATE.ScionIRN,0)
  if person.GETDEATHDATE.ScionIRN ~= "" & person.GETDEATHDATE.ScionIRN ~= "dead" then
   PersOutputCh(' + 'person.GETDEATHDATE.ScionIRN,0)
  PersOutputCr()
  marriagesANDchildren(ScionIRN,indent)
  end
/**/
 WriteLn('PERSONFILE','</TT></PRE>')
 WriteLn('PERSONFILE','</HTML>')
 Close('PERSONFILE')
 if flags.MakeGuide then do
  WriteLn('PERSONGuide','@ENDNODE')
  Close('PERSONGuide')
  end
/**/
/*
 if flags.target = "NORMAL" & ValidInfo then do
*/
 if flags.target = "NORMAL" then do
  if DoGenText then WriteLn('GenealogyText','')
  GeneaOutputCh('<'ScionIRN'>',1)
  if person.GETBIRTHDATE.ScionIRN ~= "" then
   GeneaOutputCh('  *'person.GETBIRTHDATE.ScionIRN,0)
  if person.GETDEATHDATE.ScionIRN ~= "" & person.GETDEATHDATE.ScionIRN ~= "dead" then
   GeneaOutputCh(' +'person.GETDEATHDATE.ScionIRN,0)
  if HasFATHER then do
   GeneaOutputCh('  <'FATHERIRN'>',1)
   if HasMOTHER then GeneaOutputCh(' & <'MOTHERIRN'>',1)
   end
  else do
   if HasMOTHER then GeneaOutputCh('  <'MOTHERIRN'>',1)
   end
  GeneaOutputCr() /* do not close, we have many more to go. */
  end
 return





IsNumeric: PROCEDURE
 PARSE ARG str
 return DataType(str, 'W')


/******************************** Makedir **********************************/

/* Makedir - If a directory under the given name already exists, or can be
   created, return 1, otherwise return 0. Though this function works
   correctly under Workbench 1.3, it has the same effect as the existing
   MAKEDIR; hence it is useful only under 2.0.
*/
Makedir: procedure
 ds = statef(arg(1))
 if ds='' then
  result = 'MAKEDIR'(arg(1))
 else
  result = left(ds,3) = 'DIR'
 return result

Paternal: PROCEDURE EXPOSE person. Adir flags. DoGenText PersonPrefix DBNAME DBPATH
 PARSE ARG irn, indent
 'GETPARENTS' irn
 PARENTS = RESULT
 'GETPRINCIPAL' PARENTS
 PRINCIPAL = RESULT
 'GETSPOUSE' PARENTS
 SPOUSE = RESULT
/* say 'PRINCIPAL = 'PRINCIPAL' SPOUSE = 'SPOUSE */
 'GETSEX' PRINCIPAL
 if RESULT = 'M' then do
  FIRN = PRINCIPAL
  MIRN = SPOUSE
  end
 else do
  FIRN = SPOUSE
  MIRN = PRINCIPAL
  end
 pirn = FIRN
 if 't'pirn't' ~= 'tt' then do
  Paternal(pirn,indent'    ')
  PersOutputCh(indent' ,-',0)
  if pirnLASTNAME ~= "" then PersOutputCh('<'pirn'>',1)
  if EXISTS(DBPATH'PN'pirn'.'DBNAME) then PersOutputCh(' ()',0)
  if EXISTS(DBPATH'PP'pirn'.'DBNAME) then PersOutputCh(' ()',0)
  BirthDeath(pirn)
  PersOutputCr()
  Maternal(pirn,indent'|   ')
  end
 return 0

Maternal: PROCEDURE EXPOSE person. Adir flags. DoGenText PersonPrefix DBNAME DBPATH
 PARSE ARG irn, indent
 'GETPARENTS' irn
 PARENTS = RESULT
 'GETPRINCIPAL' PARENTS
 PRINCIPAL = RESULT
 'GETSPOUSE' PARENTS
 SPOUSE = RESULT
 'GETSEX' PRINCIPAL
 if RESULT = 'M' then do
  FIRN = PRINCIPAL
  MIRN = SPOUSE
  end
 else do
  FIRN = SPOUSE
  MIRN = PRINCIPAL
  end
 pirn = MIRN
 if 't'pirn't' ~= 'tt' then do
  Paternal(pirn,indent'|   ')
  PersOutputCh(indent' `-',0)
  if pirnLASTNAME ~= "" then PersOutputCh('<'pirn'>',1)
  if EXISTS(DBPATH'PN'pirn'.'DBNAME) then PersOutputCh(' ()',0)
  if EXISTS(DBPATH'PP'pirn'.'DBNAME) then PersOutputCh(' ()',0)
  BirthDeath(pirn)
  PersOutputCr()
  Maternal(pirn,indent'    ')
  end
 return 0

marriagesANDchildren: PROCEDURE EXPOSE person. Adir flags. DoGenText PersonPrefix DBNAME DBPATH
        PARSE ARG ScionIRN,indent
 'GETNUMMARRY' ScionIRN
 TOTMARRIAGES = RESULT
/* say 'TOTMARRIAGES = 'TOTMARRIAGES */

 if 't'TOTMARRIAGES't' = 'tt' then return 0

 DO i = 0 TO TOTMARRIAGES - 1
  'GETMARRIAGE' ScionIRN i
  MARRIAGE = RESULT
  if MARRIAGE > -1 then do
   MARRIAGES = i
   end
 end
 tMARRIAGESt = 't'MARRIAGES't'
/* Say 'MARRIAGES = 'MARRIAGES tMARRIAGESt */

 if tMARRIAGESt ~= 'tMARRIAGESt' then do
  DO i = 0 TO MARRIAGES
   'GETMARRIAGE' ScionIRN i
   mFGRN = RESULT
   if mFGRN ~= "" then do
    'GETSPOUSE' mFGRN
    SPOUSE = RESULT
    if SPOUSE = ScionIRN then
     DO
     'GETPRINCIPAL' mFGRN
     SPOUSE = RESULT
     end
    PersOutputCh(indent' & ',0)
    mindent = "  "
    if i <= ( MARRIAGES - 1 ) then mindent = " :"
    PersOutputCh('<'SPOUSE'>',1)
if EXISTS(DBPATH'PN'SPOUSE'.'DBNAME) then PersOutputCh(' ()',0)
if EXISTS(DBPATH'PP'SPOUSE'.'DBNAME) then PersOutputCh(' ()',0)
    BirthDeath(SPOUSE)
    PersOutputCr()
    'GETNUMCHILD' mFGRN
    TOTCHILDREN = RESULT
/* say 'TOTCHILDREN = 'TOTCHILDREN */
    DO k = 0 TO TOTCHILDREN - 1
     'GETCHILD' mFGRN k
     mFGRNc = RESULT
     GetPerComp(mFGRNc)
     if k = ( TOTCHILDREN - 1 ) then do
      indent2 = indent||mindent" "
      PersOutputCh(indent||mindent'|_<'mFGRNc'>',1)
      end
     else do
      indent2 = indent||mindent"|"
      PersOutputCh(indent2'_<'mFGRNc'>',1)
      end
if EXISTS(DBPATH'PN'mFGRNc'.'DBNAME) then PersOutputCh(' ()',0)
if EXISTS(DBPATH'PP'mFGRNc'.'DBNAME) then PersOutputCh(' ()',0)
     BirthDeath(mFGRNc)
     PersOutputCr()

     marriagesANDchildren(mFGRNc,indent2)
     end
    end
   end
  end
 return 0

PersOutputHL: PROCEDURE EXPOSE person. DoGenText flags.
 WriteLn('PERSONFILE','<HR>')
 if flags.MakeGuide then WriteLn('PERSONGuide','')
 if DoGenText then do
   WriteLn('GenealogyText','')
   WriteLn('GenealogyText','-----------------------------------------------------------')
   WriteLn('GenealogyText','')
   end
 return 0

BirthDeath: PROCEDURE EXPOSE person. DoGenText flags.
 irn = arg(1)
/* GetPerComp(irn) */
 if person.gotten.irn = PERSON.GOTTEN. then return 0
 if person.GETBIRTHDATE.irn ~= "" then
  PersOutputCh('   * 'person.GETBIRTHDATE.irn,0)
 if person.GETDEATHDATE.irn ~= "" then
  PersOutputCh('   + 'person.GETDEATHDATE.irn,0)
 return 0

PersOutputCr: PROCEDURE EXPOSE person. DoGenText flags.
 WriteLn('PERSONFILE','')
 if flags.MakeGuide then WriteLn('PERSONGuide','')
 if DoGenText then WriteLn('GenealogyText','')
 return 0

PersOutputCh: PROCEDURE EXPOSE person. Adir DoGenText flags. PersonPrefix LastNameFl LastNameVal
 if arg(1) ~= "" then do
  if arg(2) = 0 then do
   WriteCh('PERSONFILE',arg(1))
   if flags.MakeGuide then do
    if arg(1) = ' ('flags.htmlb''flags.htmlub')' then WriteCh('PERSONGuide',' ()')
    else WriteCh('PERSONGuide',arg(1))
    end
   if DoGenText then WriteCh('GenealogyText',arg(1))
   end
  else do
   WriteCh('PERSONFILE',CheckForReplacement(arg(1)))
   if flags.MakeGuide then WriteCh('PERSONGuide',CheckGuideRepl(arg(1)))
   if DoGenText then WriteCh('GenealogyText',CheckForNAReplacement(arg(1)))
   end
 end
 return 0

PersOutputLn: PROCEDURE EXPOSE person. Adir DoGenText flags. PersonPrefix LastNameFl LastNameVal
 if arg(1) ~= "" then do
  if arg(2) = 0 then do
   WriteLn('PERSONFILE',arg(1))
   if flags.MakeGuide then WriteLn('PERSONGuide',arg(1))
   if DoGenText then WriteLn('GenealogyText',arg(1))
   end
  else do
   WriteLn('PERSONFILE',CheckForReplacement(arg(1)))
   if flags.MakeGuide then WriteLn('PERSONGuide',CheckGuideRepl(arg(1)))
   if DoGenText then WriteLn('GenealogyText',CheckForNAReplacement(arg(1)))
   end
 end
 return 0

GeneaOutputCr: PROCEDURE EXPOSE person. flags.
 WriteLn('GenealogyFile','<BR>')
 if flags.MakeGuide then WriteLn('GenealogyGuide','') 
 return 0

GeneaOutputCh: PROCEDURE EXPOSE person. Adir DoGenText flags. PersonPrefix LastNameFl LastNameVal
 if arg(1) ~= "" then do
  if arg(2) = 0 then do
   WriteCh('GenealogyFile',arg(1))
   if flags.MakeGuide then WriteCh('GenealogyGuide',arg(1))
   end
  else do
   WriteCh('GenealogyFile',CheckForReplacement(arg(1)))
   if flags.MakeGuide then WriteCh('GenealogyGuide',CheckGuideRepl(arg(1)))
   end
 end
 return 0

GeneaOutputLn: PROCEDURE EXPOSE person. Adir DoGenText flags. PersonPrefix LastNameFl LastNameVal
 if arg(1) ~= "" then do
  if arg(2) = 0 then do
   WriteLn('GenealogyFile',arg(1))
   WriteLn('GenealogyGuide',arg(1))
   end
  else do
   WriteLn('GenealogyFile',CheckForReplacement(arg(1)))
   WriteLn('GenealogyGuide',CheckGuideRepl(arg(1)))
   end
 end
 return 0

/***************************************************************
* Check for "<IRN>" and replace with Person Name (with anchor) *
***************************************************************/

CheckForReplacement: PROCEDURE EXPOSE person. flags. PersonPrefix LastNameFl LastNameVal
 PARSE ARG line "<" last
 if last = "" then return line
 RIRN = GetRIRN(last".")
 if RIRN = 0 then return line"<"last
 last = CheckforReplacement(last)
 lastend = GetEnd(last".")
 GetPerComp(RIRN)
 RIRNFILENAME = PersonPrefix || RIRN
 if flags.bold then return line'<A HREF="'RIRNFILENAME'.htm">'person.GETFULLNAME.RIRN'</A>'lastend
 if LastNameFl = -1 & person.GETLASTNAME.RIRN = LastNameVal then do
  if person.GETSEX.RIRN = "M" then
   RIRNFULLNAME = ''flags.htmlb''person.GETFIRSTNAME.RIRN''flags.htmlub''
  else RIRNFULLNAME = ''flags.htmli''person.GETFIRSTNAME.RIRN''flags.htmlui''
  end
 else do
  if person.GETSEX.RIRN = "M" then
   RIRNFULLNAME = ''flags.htmlb''person.GETFULLNAME.RIRN''flags.htmlub''
  else RIRNFULLNAME = ''flags.htmli''person.GETFULLNAME.RIRN''flags.htmlui''
  end
 return line'<A HREF="'RIRNFILENAME'.htm">'RIRNFULLNAME'</A>'lastend

/******************************************************************
* Check for "<IRN>" and replace with Person Name (without anchor) *
******************************************************************/

CheckForNAReplacement: PROCEDURE EXPOSE person. flags. PersonPrefix LastNameFl LastNameVal
 PARSE ARG line "<" last
 if last = "" then return line
/* if last = "" then return line */
 RIRN = GetRIRN(last".")
 if RIRN = 0 then return line"<"last
 last = CheckForNAReplacement(last)
 lastend = GetEnd(last".")
 GetPerComp(RIRN)
 if ~flags.bold then do
  if LastNameFl = -1 & person.GETLASTNAME.RIRN = LastNameVal then do
   if person.GETSEX.RIRN = "M" then
    RIRNFULLNAME = '[1m'person.GETFIRSTNAME.RIRN'[22m'
   else
    RIRNFULLNAME = '[3m'person.GETFIRSTNAME.RIRN'[23m'
   return line||RIRNFULLNAME lastend
   end
  else do
   if person.GETSEX.RIRN = "M" then
    RIRNFULLNAME = '[1m'person.GETFULLNAME.RIRN'[22m'
   else
    RIRNFULLNAME = '[3m'person.GETFULLNAME.RIRN'[23m'
   return line || RIRNFULLNAME lastend
   end
  end
 else do
  if LastNameFl = -1 & person.GETLASTNAME.RIRN = LastNameVal then
   RIRNFULLNAME = person.GETFIRSTNAME.RIRN
  else RIRNFULLNAME = person.GETFULLNAME.RIRN
  return line||RIRNFULLNAME lastend
  end

/****************************************************************
* Check for "<IRN>" and replace with Person Name (Guide anchor) *
****************************************************************/

CheckGuideRepl: PROCEDURE EXPOSE Adir person. flags. PersonPrefix LastNameFl LastNameVal
 PARSE ARG line "<" last
 if last = "" then return line
/* if last = "" then return line */
 RIRN = GetRIRN(last".")
 if RIRN = 0 then return line"<"last
 last = CheckGuideRepl(last)
 lastend = GetEnd(last".")
 GetPerComp(RIRN)
 RIRNFILENAME = PersonPrefix || RIRN
 if LastNameFl = -1 & person.GETLASTNAME.RIRN = LastNameVal then 
  RIRNFULLNAME = person.GETFIRSTNAME.RIRN
 else RIRNFULLNAME = person.GETFULLNAME.RIRN
 if flags.bold then 
  return line'@{" 'RIRNFULLNAME' " LINK 'Adir'/'RIRNFILENAME'.guide/Main}'lastend
 thegender = 'i'
 if person.GETSEX.RIRN = "M" then thegender = 'b'
 return line'@{" " LINK 'Adir'/'RIRNFILENAME'.guide/Main}@{'thegender'}'RIRNFULLNAME'@{u'thegender'}'lastend

GetRIRN: PROCEDURE
 PARSE ARG numb ">" last
 if last = "" then return 0
 if IsNumeric(numb) then return numb
 return 0

GetEnd: PROCEDURE
 PARSE ARG line ">" last
 if last = "" then return substr(line,1,length(line)-1)
 return substr(last,1,length(last)-1)

GetLength: PROCEDURE
 PARSE UPPER ARG names
 nonletters = length(compress(names, xrange('A','Z')))
 return Length(names) - nonletters * 4 / 10


/* create a full name from first, last, and honorifics parts */

GetFullName: PROCEDURE EXPOSE person. thelastname
 PARSE ARG firstnames "," hon
 if hon = "" then do
  if length(firstnames) > 2 then
   if substr(firstnames,length(firstnames)-1,length(firstnames)) = "V." then
    firstnames = substr(firstnames,1,length(firstnames)-2)"v."
  return firstnames thelastname
  end
 return firstnames Space(thelastname)","hon
 
MGetFullName: PROCEDURE EXPOSE person. flags. thelastname thegender
 PARSE ARG firstnames "," hon
 if flags.bold then return firstnames Space(thelastname)
 gchar = "B"
 if thegender = "f" then gchar = "I"
 if hon = "" then do
  if length(firstnames) > 2 then
   if substr(firstnames,length(firstnames)-1,length(firstnames)) = "V." then
    firstnames = substr(firstnames,1,length(firstnames)-2)"v."
  return "<"gchar">"firstnames thelastname"</"gchar">"
  end
 return "<"gchar">"firstnames Space(thelastname)","hon"</"gchar">"
 
PGetFullName: PROCEDURE EXPOSE person. flags. thelastname thegender
 PARSE ARG firstnames "," hon
 if flags.bold then return firstnames Space(thelastname)
 schar = "1"
 uchar = "2"
 if thegender = "f" then do
  schar = "3"
  uchar = "3"
  end
 if hon = "" then do
  if length(firstnames) > 2 then
   if substr(firstnames,length(firstnames)-1,length(firstnames)) = "V." then
    firstnames = substr(firstnames,1,length(firstnames)-2)"v."
  return "["schar"m"firstnames thelastname"[2"uchar"m"
  end
 return "["schar"m"firstnames Space(thelastname)","hon"[2"uchar"m"

AgeTest: PROCEDURE EXPOSE flags.
 PARSE ARG DBFile, HTMFile
 if Exists(DBFile) then do
  if Exists(HTMFile) then do
Parse value StateF(DBFile) with type size blk bits DBday DBmin DBtick com
Parse value StateF(HTMFile) with type size blk bits HTMday HTMmin HTMtick com
/* Say DBFile DBday DBmin DBtick  HTMFile HTMday HTMmin HTMtick */
   if ( DBday > HTMday ) | ( DBday = HTMday & DBmin > HTMmin ) then do
    Delete(HTMFile)
    Say DBFile 'is newer; removing 'HTMFile
    return 1
    end
   else do
    if flags.verbose then Say '  ~ 'HTMFile'  ...OK... '
    return 0
    end
  return 1
  end
 return 1
 end

CheckPathName: PROCEDURE
PARSE ARG str
/* Check if path ends with a ":". If not, append a "/" */
lastchar = right(str,1)
if right(str,1) ~= ":" & right(str,1) ~= "/" then return str'/'
return str

AskExit: PROCEDURE
 SAY '           [4m      [24m'
 SAY '===> press [7mRETURN[27m to exit...'
 SAY ' '
 PULL target
 PauseExit()
 end

PauseExit: PROCEDURE
 SAY ' '
 SAY '    [7m\                   /[27m'
 SAY '    [7m [27m\[4m                 [24m/[7m [27m'
 SAY '    [7m [27m [7m                 [27m [7m [27m'
 SAY '    [7m [27m [7m                 [27m [7m [27m'
 SAY '    [7m [27m [7m Scion2html.rexx [27m [7m [27m'
 SAY '    [7m [27m [7m                 [27m [7m [27m'
 SAY '    [7m [27m [7m                [27m [7m [27m'
 SAY '    [7m [27m [7m                 [27m [7m [27m'
 SAY '    [7m [27m [7m  Harold Ipolyi  [27m [7m [27m'
 SAY '    [7m [27m [7m                 [27m [7m [27m'
 SAY '    [7m [27m [7m                 [27m [7m [27m'
 SAY '    [7m [27m[4m/                 \[24m[7m [27m'
 SAY '    [7m/                   \[27m'
 SAY ' '
 EXIT
 end

CheckGfxCon: PROCEDURE
DoPictures = EXISTS("Sys:Tools/GfxCon")

if ~DoPictures then do
 SAY ' '
 say 'GfxCon not found in Sys:Tools - unable to include inline pictures in HTMLs'
 end
return DoPictures

Validtarget: PROCEDURE
 PARSE UPPER ARG str
 tval = substr(str,1,1)
 if verify(' BCDEFGHIJKLMOPSUVWXYZ.,<>-=\|+_)(*&^%$@!~[]{}`',tval,m) > 1 then
  return 0
 return 1


GetPerComp: PROCEDURE EXPOSE person. flags.
 PARSE ARG irn
 if irn = '' then return ""

 if ~person.gotten.irn then do
  person.gotten.irn = 1

/* name */
  'GETFIRSTNAME' irn
  person.GETFIRSTNAME.irn = RESULT
  'GETLASTNAME' irn
  person.GETLASTNAME.irn = RESULT
  thelastname = GetLastName(person.GETLASTNAME.irn)
/* requires `thelastname' above */
  person.GETFULLNAME.irn = GetFullName(person.GETFIRSTNAME.irn)
/* gender */
  'GETSEX' irn
  person.GETSEX.irn = RESULT
  thegender = GETSEX.irn
/* special names; requires `thegender' above */
  person.MGETFULLNAME.irn = MGetFullName(person.GETFIRSTNAME.irn)
  person.PGETFULLNAME.irn = PGetFullName(person.GETFIRSTNAME.irn)
/* dates */
  'GETBIRTHDATE' irn
  person.GETBIRTHDATE.irn = RESULT
  'GETDEATHDATE' irn
  person.GETDEATHDATE.irn = RESULT
/* places */
  'GETBIRTHPLACE' irn
  person.GETBIRTHPLACE.irn = RESULT
  'GETDEATHPLACE' irn
  person.GETDEATHPLACE.irn = RESULT
  end
 return 0 





 /* Capitalize last name; also handle special cases! */
 /* End users may wish to customize this code */

GetLastName: PROCEDURE

/* to use last names as is in data base, uncomment the following 2 lines: */
/* PARSE ARG str */
/* return str    */

 PARSE upper ARG str
 if str = "BAUER-GAUSS" then return "Bauer-Gauss"
 if ( str = "DE IPOLYI" ) | ( str = "DEIPOLYI" ) then return "deIpolyi"
 if str = "MC GRADY" then return "McGrady"
 if str = "MCFEE" then return "McFee"
 if str = "KIS RED" then return "KisRed"
 if str = "ROTH-HACKENSCHMIDT" then return "Roth-Hackenschmidt"
 if str = "SCHCH-GLICKHFELDEN" then return "Schch-Glickhfelden"
 if str = "VONRUDERFRUD" then return "Von Ruderfrud"
 if str = "VONHARBEN" then return "Von Harben"
 else
  DO
  spart = translate(substr(str,2,length(str)),xrange('a','z'),xrange('A','Z'))
  end
 return substr(str,1,1)Space(spart)
