/*

ConvertAliases 1.0 by Dan Fraser
This should convert AmigaELM aliases file to Voodoo address book 

*/


parse arg infile outfile

if infile='' then do
	wbmode=1
	address command 'requestchoice >nil: title="ConvertAliases" body="Welcome to ConvertAliases 1.0 by Dan J. Fraser" gadgets="OK"'
	infile=requestfile('Select AmigaELM ''aliases'' file...','file=Aliases drawer=UULib:.elm/')
	if infile='' then do
		call info('Aborted!')
		exit 5
	end 
end 
else wbmode=0

if ~open(aliasfile,infile,'R') then do
	call info('Can''t open the input file.  odd.')
	exit 5
end

if outfile='' then do
	outfile=requestfile('Select your ''Voodoo.aliases'' file...')
	if outfile='' then do
		call info('Aborted!')
		exit 5
	end
end

	if open(Valiases,outfile,'A') then do
		do while ~eof(aliasfile)
			inline=readln(aliasfile)
			if (left(inline,1)~='#') & (inline~='') then do
				parse var inline alias'='email'('name')'
				call writeln(Valiases,strip(alias)': 'strip(email)' ; "'strip(name)'" 0')
			end
		end
		call info('Done!  Thanks for using ConvertAliases.rexx!')
	end
	else
		call info('unable to open output file for some reason.  odd.')

exit 0

requestfile:procedure
	parse arg title,moreopts
	address command 'requestfile >pipe:filename title="'title'" 'moreopts
	if open(pipefile,'pipe:filename','R') then do
		inline=readln(pipefile)
		call close(pipefile)
	end
	else do
		say 'fatal error, problem making requester'
		exit 10;
	end
return strip(inline,'B','"')

request:procedure expose wbmode
	if wbmode=1 then do
		parse arg title,body,defdir
		address command 'requestchoice >pipe:filename title="'title'" body="'body'" gadgets="Yes" "No"'
		if open(pipefile,'pipe:filename','R') then do
			inline=readln(pipefile)
			call close(pipefile)
		end
		else do
			say 'fatal error, problem making requester'
			exit 10;
		end
	end
	else inline=1
return inline

info:procedure expose wbmode
	parse arg body
	if wbmode=1 then
		address command 'requestchoice >nil: title="Info" body="'body'" gadgets="oh"'
	else
		say body
return 0
